      SUBROUTINE WORKER
      implicit none

C     revised: 27 September 2012 by Hannah Leverentz 
C     revision: changed the tag number in MPI_Recv calls from 11 to numbers
C               13-45 so that each variable received from the master processor
C               has a different tag number associated with it.

      include 'mpif.h'
      include 'common.inc'

!
! A worker will remain in this loop until it recieves a message to execute a
! subroutine, or until it is given a message to exit.
!
! tags can be used many ways.  In this example, tags have the following meanings:
!
! 0  - tag recieved by worker to tell it to exit
! 12 - tag sent to manager to return a result or confirm completion
! 13+- tags received by worker to tell it to RUN SOMETHING
!
      CHARACTER*20 INPUTFILE
      INTEGER rank, ierr
      LOGICAL DONE
      INTEGER STATUS(MPI_STATUS_SIZE), NULL, TAG

      integer   natms, nfrg, nbasis, nbgq
      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer i, j, tfid(3)
      integer ekey, gradkey, hesskey
      integer nmmpp,mmpseudo       					!1110HL11
      character*80 allmmpp(1000)   					!1110HL11
      character*1 cmode							!1115HL11

      character*20 esm          !0621HQ12
c
c Added by Hai Lin, 5/11/2009
c
      integer   icaltype
c
c End by Hai Lin, 5/11/2009
c
c  added 6/15/09 by Erin Dahlke Speetzen
      integer pseudo, ncore
      character*80 core(1000), keywrds
c  end add 6/15/09 by EDS
      character*80 basis(1000), title(5) 
      character*20 bgq(maxat,5), method,mem,bkey
C  Add by Hannah Leverentz, 3/9/2011
      character*20 cpop
      integer lscreen
C  End by Hannah Leverentz, 3/9/2011
      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
      NULL=0
      DONE = .FALSE.
      DO WHILE (.NOT.DONE)
         CALL MPI_Probe(0, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr)
         IF (STATUS(MPI_TAG).GE.13) THEN			 !0927HL12 changed "LT.11" to "GE.13"
              CALL MPI_Recv(esm,20, MPI_CHARACTER,               !0621HQ12
     *                      0, 13, MPI_COMM_WORLD,status,ierr)   !0621HQ12
              CALL MPI_Recv(ekey,1,MPI_INTEGER,
     *                      0, 14, MPI_COMM_WORLD,status,ierr)
	      CALL MPI_Recv(gradkey,1,MPI_INTEGER,
     *                      0, 15, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(hesskey,1,MPI_INTEGER,
     *                      0, 16, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(natms,1, MPI_INTEGER,
     *                      0, 17, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(fragid,maxfrag*maxapf, MPI_INTEGER,
     *                      0, 18, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(cm,maxfrag*2, MPI_INTEGER,
     *                      0, 19, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(afrag,maxfrag, MPI_INTEGER,
     *                      0, 20, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(nfrg,1, MPI_INTEGER,
     *                      0, 21, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(basis,1000*80, MPI_CHARACTER,
     *                      0, 22, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(title,5*80, MPI_CHARACTER,
     *                      0, 23, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(bgq,20*maxat*5, MPI_CHARACTER,
     *                      0, 24, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(method,20, MPI_CHARACTER,
     *                      0, 25, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(geom,maxat*3, MPI_DOUBLE_PRECISION,
     *                      0, 26, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(asym,maxat*8, MPI_CHARACTER,
     *                      0, 27, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(tfid,3, MPI_INTEGER,
     *                      0, 28, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(j,1, MPI_INTEGER,
     *                      0, 29, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(nbasis,1, MPI_INTEGER,
     *                      0, 30, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(mem,20, MPI_CHARACTER,
     *                      0, 31, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(nbgq,1, MPI_INTEGER,
     *                      0, 32, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(i,1, MPI_INTEGER,
     *                      0, 33, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(bkey,20, MPI_CHARACTER,
     *                      0, 34, MPI_COMM_WORLD,status,ierr)
c
c Added by Hannah Leverentz, 5/20/2009
c
              CALL MPI_Recv(icaltype, 1, MPI_INTEGER,
     *                      0, 35, MPI_COMM_WORLD,status,ierr)
c
c End by Hannah Leverentz, 5/20/2009
c Added 6/16/09 by Erin Dahlke Speetze
              CALL MPI_Recv(ncore, 1, MPI_INTEGER,
     *                      0, 36, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(pseudo, 1, MPI_INTEGER,
     *                      0, 37, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(keywrds,80,MPI_CHARACTER,
     *                      0, 38, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(core,1000*80,MPI_CHARACTER,
     *                      0, 39, MPI_COMM_WORLD,status,ierr)
c  endadd 6/16/09
C  Add by Hannah Leverentz, 3/9/2011
              CALL MPI_Recv(cpop,20,MPI_CHARACTER,
     *                      0, 40, MPI_COMM_WORLD,status,ierr)
C  End by Hannah Leverentz, 3/9/2011
              CALL MPI_Recv(lscreen,1,MPI_INTEGER,
     *                      0, 41, MPI_COMM_WORLD,status,ierr)
              CALL MPI_Recv(allmmpp,1000*80,MPI_CHARACTER,             !1110HL11
     *                      0, 42, MPI_COMM_WORLD,status,ierr)         !1110HL11
              CALL MPI_Recv(nmmpp,1,MPI_INTEGER,                       !1110HL11
     *                      0, 43, MPI_COMM_WORLD,status,ierr)         !1110HL11
              CALL MPI_Recv(mmpseudo,1,MPI_INTEGER,                    !1110HL11
     *                      0, 44, MPI_COMM_WORLD,status,ierr)         !1110HL11
              CALL MPI_Recv(cmode,1,MPI_CHARACTER,                     !1115HL11
     *                      0, 45, MPI_COMM_WORLD,status,ierr)         !1115HL11
c
c!            if (ekey .eq. 1) then
C
C  If this is an EE-MB-CE calculation, then "i" will be equal to -1; otherwise, 	!0516HL12
C   "i" will be equal to 1, 2, or 3 for monomer, dimer, or trimer, respectively.	!0516HL12
C   if this is an EE-MB-CE calculation, then we need to call "setuphf" to run		!0516HL12
C   the full-system hartree fock calculation.  Otherwise we call eg09 as usual.		!0516HL12
C											!0516HL12
              if(esm .eq. 'g09') then                                    !0621HQ12

                 if (i.eq.-1) then                                       !0516HL12
                    call setuphf(natms,method,basis,nbasis,bkey,cm,asym, !0516HL12
     *                   geom,icaltype,keywrds,pseudo,core,ncore,        !0516HL12
     *                   mem)                                            !0516HL12
                 else                                                    !0516HL12
                    call eg09(natms,fragid,cm,afrag,nfrg,basis,
     *                   title,bgq,method,geom,asym,tfid,j,nbasis,
                    
c
c revised by Hai Lin, 5/11/2009
c revised 6/15/09 by EDS
     *                   mem,nbgq, i,bkey,icaltype,keywrds,core,
C     Add by Hannah Leverentz, 3/9/2011
c     *                     pseudo,ncore)
     *                 pseudo,ncore,cpop,lscreen,allmmpp,nmmpp,mmpseudo, !1110HL11 add allmmpp,nmmpp,mmpseudo
     *                   cmode) !1115HL11
C  End by Hannah Leverentz, 3/9/2011
                 endif                                                   !0516HL12
              elseif(esm .eq. 'molpro') then                             !0621HQ12
                 if (i.eq.-1) then                                       !0625HQ12
                    call molphf(natms,method,basis,nbasis,bkey,cm,asym,  !0625HQ12
     *                   geom,icaltype,keywrds,pseudo,core,ncore,        !0625HQ12
     *                   mem)                                            !0625HQ12
                 else                                                    !0625HQ12
                    call emolp(natms,fragid,cm,afrag,nfrg,basis,         !0621HQ12
     *                   title,bgq,method,geom,asym,tfid,j,              !0621HQ12
     *                   nbasis,mem,nbgq,i,bkey,icaltype,                !0621HQ12
     *                   keywrds,core,pseudo,ncore,cpop,lscreen,         !0621HQ12
     *                   allmmpp,nmmpp,mmpseudo,cmode)                   !0621HQ12
                 endif                                                   !0625HQ12
              endif                                                      !0625HQ12

c end revision 6/15/09 by EDS
c     *                     mem,nbgq, i,bkey)
c
c end by Hail Lin, 5/11/2009
c
c  Revised by Hannah Leverentz, 5/21/2009:
c
c  The revisions by Hai Lin removed the necessity for 
c  the gg09 and hg09 subroutines; therefore the calls to these 
c  subroutines and the corresponding if...endif structure
c  have been commented out:
c
c!             elseif (gradkey .eq. 1) then
c!                call gg09(natms,fragid,cm,afrag,nfrg,basis,
c!   *                     title,bgq,method,geom,asym,tfid,j,nbasis,
c!   *                     mem,nbgq, i,bkey)
c!             elseif (hesskey .eq. 1) then
c!                call hg09(natms,fragid,cm,afrag,nfrg,basis,
c!   *                     title,bgq,method,geom,asym,tfid,j,nbasis,
c!   *                     mem,nbgq,i,bkey)
c!             endif
c
c End of revision by Hannah Leverentz, 5/21/2009
c
            CALL MPI_Send(NULL,1,MPI_INTEGER,0, 12,MPI_COMM_WORLD,
     *                   ierr)
         ELSEIF (STATUS(MPI_TAG).EQ.0) THEN
            CALL MPI_Recv(NULL,1, MPI_INTEGER,0,0, MPI_COMM_WORLD,
     *                    status,ierr)
            DONE = .TRUE. 
         ELSE
            PRINT *, 'ERROR: UNKNOWN TAG CAUGHT BY WORKER RANK: ',rank,
     *               ' TAG: ',tag 
         ENDIF
      ENDDO
      RETURN
      END SUBROUTINE

