#!/usr/bin/perl
#
#  Gaussian 09 shuttle script for external optimization
#
#  created : May 24th, 2007 by E. E. Dahlke
#  revised :
#

##########################################################################

#                      #########################
#                      #                       #  
########################      Set g09 Path     ###########################
#                      #                       #
#                      #########################

#
#  You might need to update the 'gausspath' here
#     

use Cwd;
# calhoun 
# $g09 = '/soft/gaussian/g09.a02/g09';

# koronis
# $g09 = '/soft/koronis/gaussian/g09.a02.MNGFM5.0/g09';
  $g09 = '/soft/koronis/gaussian/g09.c01.MNGFM6.2/g09';

# itasca
# $g09 = '/soft/gaussian/g09.a02/g09';

#     
# This variable has to be set to the directory where GAUSSIAN files are 
# located. 
#
# You might need to update other directories for GAUSSIAN as well.
#
# (1) Directory of GAUSSIAN executable files:
#

$ENV{"GAUSS_EXEDIR"}="$g09";

#
# (2) Scratch Directory:
#     
#     A temporary subdirectory is created within the scratch directory 
#     named after the process number.
#
#     All Gaussian scratch files will go into that diretory to allow
#     easier deletion afterwards.
#

$scratchdir="/scratch/uvdev1/hannahl";


mkdir "$scratchdir" || die "Failed to create directory $scratchdir!!\n";
$ENV{"GAUSS_SCRDIR"}="$scratchdir";

#                          #################
#                          #               #  
############################   Runs G09    ###############################
#                          #               #
#                          #################
  
system ("$g09/g09 < $ARGV[0] > $ARGV[1]");

#
# End of script
#
##########################################################################

