C
C  Written by Erin Dahlke,      2007
C  Revised by Hai Lin,          2009
C
C  maxat is the max number of atoms allowed in the system
C  maxapf  is the max number of atoms allowed perl fragment
C  maxdim  is the max number of dimers allowed in the system			!0516HL12
C  maxfrag is the max number of fragments 
C  maxe is the maximum number of energies that can be stored 
C       in the energy arrays.  for example, if you run a CCSD(T)
C       calculation the Test.FChk file will list the 
C       SCF,MP2,MP3,MP4 etc. energies.  This sets how many of them 
C       will be included in the energy arrays.
C  maxjob is the maximum total number of oligomers (mon + dim + tri)		!0516HL12
C         allowed in the system plus one to account for a fullhf		!0516HL12
C         calculation if eembce option is selected.				!0516HL12

      integer maxat, maxapf, maxfrag, maxe, maxlist, maxhess
      integer maxdim, maxjob							!0516HL12
      parameter (maxat = 400)
      parameter (maxapf = 20)
      parameter (maxfrag = maxat/maxapf)
      parameter (maxe = 15)					!1115HL11 changed from 10 to 15
      parameter (maxlist = maxfrag*(maxfrag-1)*(maxfrag-2)/6)
      parameter (maxdim  = maxfrag*(maxfrag-1)/2)				!0516HL12
      parameter (maxjob  = maxfrag + maxdim + maxlist + 1)			!0516HL12
      parameter (maxhess = 3*maxat*(3*maxat-1)/2)
      double precision geom(maxat,3)
      character*8 asym(maxat)


C  Add by Hannah Leverentz, 3/30/2011
c
c     1 Angstrom = 1.88972612 bohr
c     1 debye    = 2.54174623 e*bohr         ! HL110413 bug fix
c
      double precision ang2br,au2debye       ! HL110413 bug fix
      parameter (ang2br = 1.88972612)   
      parameter (au2debye = 2.54174623)      ! HL110413 bug fix
c
C  End by Hannah Leverentz, 3/30/2011

C
C Begin Hai Lin, 5/11/2009
C
C Here, we define the OIONM keywords to be used for calling Gaussian
C
      character*40 typekey1, typekey2, typekey22, typekey3, typekey4
      character*40 typekey33                                                !0213HL12
      parameter (typekey1 = 'sp ')
      parameter (typekey2 = 'opt=(maxcyc=1,nomicro,cartesian) ')
      parameter (typekey22 = 'force ')
      parameter (typekey3 = 'freq ')
      parameter (typekey33='opt=(maxcyc=1,nomicro,cartesian,calcfc) ')      !0213HL12
      parameter (typekey4 = 'opt=(nomicro) ')

      character*40 mmkey, connkey, scfkey
      character*12 oniomkey, mmprmkey
      character*4 keykey
      parameter (keykey   = '#p ') 
      parameter (oniomkey = 'oniom( ')
      parameter (mmkey    = ':amber=softfirst)=(scalecharge=555) ')
      parameter (connkey  = 'fchk=all geom=connectivity nosym ')
      parameter (mmprmkey = 'NonBon  0 1 ')
      parameter (scfkey   = 'SCF=(tight,maxcycle=500,xqc) ')

c
c  Cap atom name in qm and mm (amber96) calculations                    
c      
      integer, parameter     :: capams        = 1
      character*2, parameter :: captypname    = 'HC'
      character*2, parameter :: qmtypname     = 'CT'
      character*2, parameter :: capname       = 'H '
      integer, parameter     :: chargeams     = 2
      character*2, parameter :: chargename    = 'He'
      character*2, parameter :: chargetypname = 'HC'

      double precision, parameter :: oniomqmcharge = 0.0  
c            

C
C Here, we define a global flag: idebug 
C This flag, if set to 1, will trigger output of debugging info
C
      integer idebug
C
C
C End by Hai Lin, 5/11/2009
C
