c*****************************************************************************
C
C      EHOOKS
C
c******************************************************************************
C
C      this is the subroutine to call the appropriate energy hook
C
C       created : September 10, 2006 by E. E. Dahlke
C       revised : February 12, 2007 by E. E. Dahlke
C	          May 30, 2007 by E. E. Dahlke
c                 May 11, 2009 by Hai Lin
C                 June 10, 2009 by Erin Dahlke Speetzen
C                 March 9, 2011 by Hannah Leverentz
C       purpose : to call the right energy hook

      subroutine ehooks(natms,rstrt,eemb,fragid,cm,afrag, nfrg,
     *                  basis,title,bgq,esm,method,geom,asym,nbasis,
C  Add by Hannah Leverentz, 3/9/2011
c    *                  mem,nbgq,bkey,keywrds,core,pseudo,ncore)
     *                  mem,nbgq,bkey,keywrds,core,pseudo,ncore,cpop,
     *                  lscreen,allmmpp,nmmpp,mmpseudo,   !0603BW11 add lscreen  0825BW11 add allmmpp,nmmpp,mmpseudo
     *                  leembce)                          !1115HL11
C  End by Hannah Leverentz, 3/9/2011


      implicit none
      include 'common.inc'

      integer   natms, rstrt, eemb,  nfrg, nf,nbasis, nbgq
      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer   frglst(maxlist,3), iistrt, jstrt
      integer   joblist(maxjob,5),nolig(3),imrk                                 !0516HL12
      integer   nm, nd, nt, tstrt, tfin, tend
      integer i, j,k, tfid(3) 
      integer donef(maxjob),njtc                                                !0516HL12

c
c Added by Hai Lin, 5/11/2009
c
      integer   icaltype 
c
c End by Hai Lin, 5/11/2009A
C Added by EDS 6/10/09

      integer pseudo, ncore
      character*80 keywrds, core(1000)
C  end by EDS 6/10/09
C  Add by Hannah Leverentz, 3/9/2011
      character*20 cpop
C  End by Hannah Leverentz, 3/9/2011
c
      integer lscreen     !0603BW11
      integer leembce     !1115HL11
      character*80 basis(1000), title(5)
c      character*20 bgq(maxat,2), esm, method,mem,  command,bkey    !0602BW11
      character*20 bgq(maxat,5), esm, method,mem,  command,bkey      !0602BW11
      character*30 tout
      character*6 tof
      character*1 cmode		    !1115HL11
      integer nmmpp,mmpseudo        !0825BW11
      character*80 allmmpp(1000)    !0825BW11

c
c Added by Hai Lin, 5/11/2009
c
c   This indicates energy calculations when calling eg09
c
      icaltype = 0 
c
c End by Hai Lin, 5/11/2009
c

c Initialize the joblist array to zero.  See the comments at the        !0516HL12
c  beginning of the updtjobs subroutine for a description of the        !0516HL12
c  contents of the joblist array.                                       !0516HL12
c                                                                       !0516HL12
      joblist = 0                                                       !0516HL12
      njtc    = 0                                                       !0516HL12
      imrk    = 0                                                       !0516HL12

      do i = 1, eemb                                                    !0516HL12  rewrote
         call getfrag(nfrg,i,nf,frglst)                                 !0516HL12  this
         write(tout,*) i                                                !0516HL12  entire
         tfin = 1                                                       !0516HL12  section -
         tend = 1                                                       !0516HL12  deleted
         call fchar(tout,tfin,tend)                                     !0516HL12  old lines
         tstrt = tfin                                                   !0516HL12  and replaced
         call fspace(tout,tfin,tend)                                    !0516HL12  with these.
         tfin = tfin - 1                                                !0516HL12
         tof = tout(tstrt:tfin) // '.eemb'                              !0516HL12
         call updtjobs(rstrt,i,nf,frglst,njtc,tout,tstrt,tfin,imrk,     !0516HL12
     *                 joblist,donef)                                   !0516HL12
         nolig(i) = nf                                                  !0516HL12
      end do                                                            !0516HL12
                                                                        !0516HL12
                                                                        !0516HL12
C   if an eembce calculation is requested, the last job                 !0516HL12
C   described in joblist will be the full hartree-fock                  !0516HL12
C   calculation, denoted by a value of "-1" in each column              !0516HL12
C   of row 1:                                                           !0516HL12
                                                                        !0516HL12
      if (leembce.eq.1) then                                            !0516HL12
        cmode(1:1) = '1'                                                !0516HL12
        imrk = imrk + 1                                                 !0516HL12
        njtc = njtc + 1                                                 !0516HL12
        do i=1,5                                                        !0516HL12
          joblist(imrk,i) = -1                                          !0516HL12
        end do                                                          !0516HL12
        if (rstrt.ne.0) then                                            !0523HL12
          call fndstrt3(imrk,-1,donef,njtc,'null',1,1)                  !0523HL12
        endif                                                           !0523HL12
      else                                                              !0516HL12
        cmode(1:1) = '0'                                                !0516HL12
      end if                                                            !0516HL12

C  write and run the electronic structure input files

      do i = 1, imrk                                                 !0516HL12  This portion 
        if (donef(i).eq.0) then                                      !0516HL12  of the code 
          do k = 1, 3                                                !0516HL12  rewritten; it
            tfid(k) = joblist(i,k+2)                                 !0516HL12  replaces a 
          end do                                                     !0516HL12  section of the
          if (esm .eq. 'g09') then                                   !0516HL12  older code.
            if (tfid(1).eq.-1) then				     !0523HL12
              call setuphf(natms,method,basis,nbasis,bkey,cm,asym,   !0523HL12
     *                     geom,icaltype,keywrds,pseudo,core,ncore,  !0523HL12
     *                     mem)					     !0523HL12
            else						     !0523HL12
              call eg09(natms,fragid,cm,afrag,nfrg,basis,            !0516HL12
     *                  title,bgq,method,geom,asym,tfid,joblist(i,2),!0516HL12
     *                  nbasis,mem,nbgq,joblist(i,1),bkey,icaltype,  !0516HL12
     *                  keywrds,core,pseudo,ncore,cpop,lscreen,      !0516HL12
     *                  allmmpp,nmmpp,mmpseudo,cmode)                !0516HL12
            endif						     !0523HL12
          elseif (esm .eq. 'nwchem') then                            !0516HL12
C              call enwchem()                                        !0516HL12
          elseif (esm .eq. 'molpro') then                            !0618HQ12
             if (tfid(1).eq.-1) then                                 !0622HQ12
                call molphf(natms,method,basis,nbasis,bkey,cm,asym,  !0622HQ12
     *                     geom,icaltype,keywrds,pseudo,core,ncore,  !0622HQ12
     *                     mem)					     !0622HQ12
             else		                                     !0622HQ12
                call emolp(natms,fragid,cm,afrag,nfrg,basis,         !0618HQ12
     *                  title,bgq,method,geom,asym,tfid,joblist(i,2),!0618HQ12
     *                  nbasis,mem,nbgq,joblist(i,1),bkey,icaltype,  !0618HQ12
     *                  keywrds,core,pseudo,ncore,cpop,lscreen,      !0618HQ12
     *                  allmmpp,nmmpp,mmpseudo,cmode)       
             end if             !0622HQ12
          end if                !0516HL12
       end if                   !0516HL12
      end do                    !0516HL12

c  write out the energy information to the output file

c  Add by Hannah Leverentz, 3/9/2011
c     call wg09e(eemb,nfrg)
      call wg09e(eemb,nfrg,fragid,natms,asym,cpop,leembce)	!1115HL11 added leembce
c  End by Hannah Leverentz, 3/9/2011

      return

      end

c******************************************************************************
C
C      WG09E
C
c******************************************************************************
C
C      created : May 30, 2007 by E. E. Dahlke
C      revised : March 9, 2011 by H. R. Leverentz
C      purpose : to write the results of an energy calculation to the output file
C
c  Add by Hannah Leverentz, 3/9/2011
c     subroutine wg09e(eemb,nfrg)
      subroutine wg09e(eemb,nfrg,fragid,natms,asym,cpop,leembce)	!1115HL11 added leembce
c  End by Hannah Leverentz, 3/9/2011

      implicit none
      include 'common.inc'
      integer eemb, i, j, nfrg, nf
      integer frglst(maxlist,3), eflg(maxe)
      integer leembce						!1115HL11 
      double precision menergy(maxe), denergy(maxe)
      double precision tenergy(maxe), v1(maxe), v2(maxe), v3(maxe)
      double precision eepa(maxe), ee3b(maxe)
      double precision v1ce(maxe), v2ce(maxe), v3ce(maxe)	!1115HL11
      double precision eepace(maxe), ee3bce(maxe)		!1115HL11
      character*6 t1                                            !0213HL12 changed tof from a 6-char variable
      character*2 tof                                           !0213HL12  to a 2-character variable
      character*30 etype(maxe)
c  Add by Hannah Leverentz, 3/9/2011
      character*20 cpop
      integer fragid(maxfrag,maxapf), natms
      double precision dippa(3), dip3b(3), mdip(3), ddip(3), tdip(3)
      double precision totdippa, totdip3b
      double precision mqqm(maxat),dqqm(maxat),tqqm(maxat)
      double precision qqmpa(maxat),qqm3b(maxat)
c  End by Hannah Leverentz, 3/9/2011
      double precision dip1b(3),totdip1b,qqm1b(maxat)		!1110HL11
      double precision ehf					!1115HL11

C  zero all energies
      do i = 1, maxe
         eepa(i) = 0.0d0
         ee3b(i) = 0.0d0
      end do

c  Add by Hannah Leverentz, 3/2/2011
c 
C  zero all dipoles
      do i = 1, 3
        dip1b(i) = 0                                    ! 1110HL11
        dippa(i) = 0
        dip3b(i) = 0
      end do
c 
C  zero the partial charges obtained from oligomer wave functions
      mqqm = 0
      dqqm = 0
      tqqm = 0
c 
C  zero the eepa and ee3b estimates of partial charges from the wave function
C    of the entire system
      qqm1b = 0                                         ! 1110HL11
      qqmpa = 0
      qqm3b = 0
c 
c  End by Hannah Leverentz, 3/2/2011

C  read in the energies

      do i = 1, eemb
         call getfrag(nfrg,i,nf,frglst)
         if (i .eq. 1) then
             tof = '_1'                                 !0213HL12 changed tof from '1.eemb' to '_1'
c  Add by Hannah Leverentz, 3/2/2011
c            call g09oute(tof,nf,menergy,eflg,etype)
             call g09oute(tof,nf,fragid,frglst,menergy,eflg,etype,
     *                    mdip,mqqm)
c  End by Hannah Leverentz, 3/2/2011
         elseif (i .eq. 2) then
             tof = '_2'                                 !0213HL12 changed tof from '2.eemb' to '_2'
c  Add by Hannah Leverentz, 3/2/2011
c            call g09oute(tof,nf,denergy,eflg,etype)
             call g09oute(tof,nf,fragid,frglst,denergy,eflg,etype,
     *                    ddip,dqqm)
c  End by Hannah Leverentz, 3/2/2011
         elseif (i .eq. 3) then
             tof = '_3'                                 !0213HL12 changed tof from '3.eemb' to '_3'
c  Add by Hannah Leverentz, 3/2/2011
c            call g09oute(tof,nf,tenergy,eflg,etype)
             call g09oute(tof,nf,fragid,frglst,tenergy,eflg,etype,
     *                    tdip,tqqm)
c  End by Hannah Leverentz, 3/2/2011
         end if
       end do

C  calculate the EEPA and EE3B energies, and also the v1, v2, and v3 terms
      do j = 1, maxe
          if (eflg(j) .eq. 1 ) then
              eepa(j) = denergy(j) - (nfrg-2)*menergy(j)
              v1(j) = menergy(j)
              v2(j) = denergy(j) - (nfrg-1)*menergy(j)
          end if
          if (eemb .eq. 3) then
            if (eflg(j) .eq. 1 ) then
                ee3b(j) = tenergy(j) - (nfrg-3)*denergy(j)
                ee3b(j) = ee3b(j) + (nfrg-2)*(nfrg-3)*menergy(j)/2
                v3(j) = tenergy(j) - (nfrg-2)*denergy(j) +
     *                     (nfrg-2)*(nfrg-1)*menergy(j)/2
            end if
          end if
      end do

C  write header to file with information about V1, V2, and V3 and
C  what types of energy are reported

      if (eemb .eq. 2) then
         write(2,1210)
      elseif (eemb .eq. 3) then
         write(2,1220)
      end if

C  write V1, V2, and V3 (if appropriate to output file for each type of energy

      do i = 1, maxe
         if (eflg(i) .eq. 1) then
             if (eemb .eq. 2 ) then
                write(2,1230) etype(i), v1(i), v2(i)
             elseif (eemb .eq. 3) then
                write(2,1240) etype(i), v1(i), v2(i), v3(i)
             endif
         end if
      end do

C  write header to file with information about EEPA/EE3B and what types
C  of energy are reported
      if (eemb .eq. 2) then
          write(2,1300)
      elseif (eemb .eq. 3) then
          write(2,1400)
      end if

C  write eepa and ee3m (if appropriate) to output file for each type of energy

      do i = 1, maxe
         if (eflg(i) .eq. 1) then
            if (eemb .eq. 2) then
               write(2,1100) etype(i), eepa(i)
            elseif (eemb .eq. 3) then
               write(2,1200) etype(i), eepa(i), ee3b(i)
            end if
         end if
      end do

c  If this is an EE-MB-CE calculation, then read in the full-system     !1115HL11
c   HF energy from the file "fullhf_1.txt", calculate the EE-MB-CE	!1115HL11
c   energy, and print the results to the output file.                   !1115HL11
c									!1115HL11
      if (leembce.eq.1) then                                            !1115HL11
        call getfhfe(ehf)                                               !1115HL11
        call calcmbce(eemb,etype,eflg,ehf,v1,v2,v3,v1ce,v2ce,v3ce,	!1115HL11
     *                eepace,ee3bce)					!1115HL11
      endif                                                             !1115HL11

C  Add by Hannah Leverentz, 3/9/2011
c 
C  calculate the EEPA and EE3B dipole moments
c 
      do j = 1, 3
         dip1b(j) = mdip(j)                                             ! 1110HL11
         dippa(j) = ddip(j) - (nfrg-2)*mdip(j)
         if (eemb .eq. 3) then
            dip3b(j) = tdip(j) - (nfrg-3)*ddip(j)
            dip3b(j) = dip3b(j) + (nfrg-2)*(nfrg-3)*mdip(j)/2
         endif
      end do
c
c  calculate the EEPA and EE3B total dipole
c					
      totdip1b = sqrt(dip1b(1)**2 + dip1b(2)**2 + dip1b(3)**2)          ! 1110HL11
      totdippa = sqrt(dippa(1)**2 + dippa(2)**2 + dippa(3)**2)
      totdip3b = sqrt(dip3b(1)**2 + dip3b(2)**2 + dip3b(3)**2)
c 
C  write dipole moment information
      write(2,1501)
c 
      write(2,1504) dip1b(1)*au2debye, dip1b(2)*au2debye,       ! 1110HL11
     *              dip1b(3)*au2debye, totdip1b*au2debye        ! 1110HL11
      write(2,1502) dippa(1)*au2debye, dippa(2)*au2debye,       ! HL110413 bug fix
     *              dippa(3)*au2debye, totdippa*au2debye        ! HL110413 bug fix
      if (eemb .eq. 3) then
          write(2,1503) dip3b(1)*au2debye, dip3b(2)*au2debye,   ! HL110413 bug fix
     *                  dip3b(3)*au2debye, totdip3b*au2debye    ! HL110413 bug fix
      end if
c 
C Calculate the atomic partial charges
c 
      do j = 1, natms
         qqm1b(j) = mqqm(j)                                     ! 1110HL11
         qqmpa(j) = dqqm(j) - (nfrg-2)*mqqm(j)
         if (eemb .eq. 3) then
            qqm3b(j) = tqqm(j) - (nfrg-3)*dqqm(j)
            qqm3b(j) = qqm3b(j) + (nfrg-2)*(nfrg-3)*mqqm(j)/2
         endif
      end do
c  
C write the atomic partial charges to the output file
c 
      if (cpop(1:4).ne."none") then
        write(2,1530)
        write(2,1540) cpop
        if (eemb.eq.2) then
          write(2,1550)
          do j = 1, natms 
            write(2,1560) j, asym(j), qqm1b(j), qqmpa(j)        ! 1110HL11  added qqm1b(j)
          end do
        else if (eemb.eq.3) then
          write(2,1570)
          do j = 1, natms
            write(2,1580) j, asym(j), qqm1b(j), qqmpa(j), qqm3b(j)      ! 1110HL11  added qqm1b(j)
          end do
        end if
      end if
c 
C  End by Hannah Leverentz, 3/9/2011

      return

 9999 write(2,1010) tof
 1010 format (/3x, 'ERROR:  could not open file ', a6)

 1100 format(3x,a30,f20.10)
 1200 format(3x,a30,f20.10,t60,f25.10)
 1210 format(/,/3x,'Type of Energy',t40, '  V1 (Hartrees)  ', t60,
     *        '  V2 (Hartrees)  ',/3x,'--------------',t40,
     *        '-----------------', t60,'-----------------')
 1220 format(/,/3x,'Type of Energy',t40, '  V1 (Hartrees)  ', t60,
     * '  V2 (Hartrees)  ',t80, '  V3 (Hartrees)  ',/3x,
     * '--------------',t40,'-----------------', t60,
     * '-----------------',t80, '-----------------')
 1230 format(3x,a30,f20.10,t55,f20.10)
 1240 format(3x,a30,f20.10,t55,f20.10,t75,f20.10)
 1300 format(/,/3x,'Type of Energy',t35, 'EE-PA Energy (Hartrees)',
     *          /3x,'--------------',t35, '-----------------------')
 1400 format(/,/3x,'Type of Energy',t35,'EE-PA Energy (Hartrees)',
     *       t65, 'EE-3B Energy (Hartrees)',/3x,'--------------',t35,
     *      '-----------------------',t65,'-----------------------')
C  Add by Hannah Leverentz, 3/9/2011
 1501 format(/3x,/'Dipole Moment (in debye)',//'Warning: for ',           
     *       'correlated wave function methods such as MP2 and ',        
     *       'CCSD the dipole ',/9x,'moment is not calculated by ',     
     *       'Gaussian 09',//20x,'X',15x,'Y',15x,'Z',13x,'TOTAL')
 1502 format(/3x,'EEPA: ', f16.8, f16.8, f16.8, f16.8)		
 1503 format(/3x,'EE3B: ', f16.8, f16.8, f16.8, f16.8)	
 1504 format(/3x,'EE1B: ',f16.8, f16.8, f16.8, f16.8)                   ! 1110HL11
 1530 format(/,/3x,'-----------------------------------------------',
     *         /3x,'             EE-MB CHARGE ANALYSIS',
     *         /3x,'-----------------------------------------------')
 1540 format(/3x,'Method of Charge Analysis: ',a20)
 1550 format(/3x,'                       EE-1B',9x,'EE-PA',             ! 1110HL11
     *       /3x,'Atom #    Element    Charge (e)    Charge (e)',       ! 1110HL11
     *       /3x,'------    -------   ------------  ------------')      ! 1110HL11
 1560 format(3x,i6,4x,a7,3x,f12.6,2x,f12.6)                             ! 1110HL11
 1570 format(/3x,'                       EE-1B',9x,'EE-PA',9x,'EE-3B',  ! 1110HL11
     *       /3x,'Atom #    Element    Charge (e)    Charge (e)',       ! 1110HL11
     *           '    Charge (e)',                                      ! 1110HL11
     *       /3x,'------    -------   ------------  ------------',      ! 1110HL11
     *           '  ------------')                                      ! 1110HL11
 1580 format(3x,i6,4x,a7,3x,f12.6,2x,f12.6,2x,f12.6)                    ! 1110HL11
C  End by Hannah Leverentz, 3/9/2011


      end


c******************************************************************************
C
C      EG09
C
c******************************************************************************
C
C      created : October 10, 2006 by E. E. Dahlke
C      revised : May 11,     2009 by Hai Lin
C                June 10, 2009 by Erin Dahlke Speetzen
C                March 9, 2011 by Hannah Leverentz
C
C      purpose :  write the G09 input files
C      Revision: Change to use oniom so that force and hessian is available
C                on background charges; the self-energy and derivatives are
c                computed by an additional mm calculation and are subtracted. 
c                Also add one arguement icaltype to pass the info --- whether 
c                to write an energy, gradient, or hessian input --- thus, 
c                this subroutine will write the input for all three types of
c                calculations.   
c                9 Mar 2011: Allow EE-MB population/charge analysis to be done.

      subroutine eg09(natms,fragid,cm,afrag,nfrg,basis,title,bgq,
     *                method,geom,asym,tfid,fn,nbasis,mem,nbgq,ee,bkey,
C  Add by Hannah Leverentz, 3/9/2011
c    *                icaltype,keywrds,core,pseudo,ncore)
     *                icaltype,keywrds,core,pseudo,ncore,cpop,lscreen,
     *                allmmpp,nallmmpp,mmpseudo,cmode)  !0603BW11 add lscreen, 0825BW11 add allmmpp,nallmmpp; 1115HL11 add cmode

C  End by Hannah Leverentz, 3/9/2011


      implicit none
      include 'common.inc'

      integer   natms,  nfrg, fn, fn2, nbasis, len, bstr, ncore, pseudo
      integer   mfin, mend, bfin, bend, tbeg, tend,tstrt,ierr
      integer   chrg, mlt, nbgq, flg, id,ee, estrt, eend, ebeg
      integer   i,j
c
c Added by Hai Lin, 5/11/2009
c These control the normal and oniom input names
c
      integer      lsymbol,  ltypname 
      integer      itotalbq, itotalqm, itotal
      integer      inormal,  icaltype
      integer      jj, kk
c
c End by Hai Lin, 5/11/2009
c

      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer   tfid(3), istrt, iend, strt(3), end(3)
      character*80 basis(1000), title(5), temp, command, temp2, eec
      character*80 temp3, core(1000), keywrds, temp4
      character*20 bgq(maxat,5), method, infile, name(3),mem, bq  !0603BW11 bgq(maxat,2) to bgq(maxat,5) 
      character*20 chkfl, bkey
c
c Added by Hai Lin, 5/11/2009
c
      character*1  cmode                                         !1115HL11
      character*2  atmsymbol, typname
      character*2  mmatmsymbol, mmtypname
      character*3  ccaltype, cnormal
      character*22 mminfile
c
c End by Hai Lin, 5/11/2009
c
      double precision fgeom(maxapf,3)

C  Add by Hannah Leverentz, 3/9/2011
      character*20 ctotalqm
      character*20 cpop,popkey
      integer ipop,pfin,pkfin
C  End by Hannah Leverentz, 3/9/2011
C  Add by Hannah Leverentz, 4/11/2011
      integer qbeg,qend
C  End by Hannah Leverentz, 4/11/2011
C
C  Add by Bo Wang, 6/3/2011  variables used for the screened charges
      integer lscreen                                                   
      integer npower(50)
      double precision zeta,nscn,nuc,acharge
      double precision exponent(50),coeff(50)
      double precision stoexp(15,15),stocoeff(15,15)
      double precision bq1                                              !bq1 is double precision
      integer k,atnum,index,nterm,ngto1                             
      integer ngterm,immpp,nmmpp,nallmmpp,mmpseudo,maxl              !0825BW11
      character*80 mmpp(50)                                          !0825BW11 the mm pseudopotentials for the charge
      character*80 allmmpp(1000)                                     !0825BW11 all mm pseudopotentials
 
      ngto1=3                                                           !0603BW11 expand one slater function to 3 gaussian functions
c factors to convert STO into 3 GTO                                     
      data (stocoeff(3,index),index=1,3)/                               
     &  0.107150,0.343808,0.355483 /                                    
      data (stoexp(3,index),index=1,3)/                                 
     &  0.109818,0.405771,2.22766 /                                     
c factors to convert STO into 6 GTO                                     
      data (stocoeff(6,index),index=1,6)/                               
     &  0.021221,0.131906,0.238573,0.241818,0.184113,0.121984 /         
      data (stoexp(6,index),index=1,6)/                                 
     &  0.065110,0.158088,0.407099,1.185060,4.235920,23.103000 /        
c factors to convert STO into 9 GTO                                     
      data (stocoeff(9,index),index=1,9)/                               
     &  0.047713,0.074983,0.111897,0.154809,0.191480,0.195519,          
     &  0.141046,0.053483,0.005656 /                                      
      data (stoexp(9,index),index=1,9)/                                 
     & 153.776713,28.206753,7.899558,2.721478,1.067073,0.457904,        
     &  0.209886,0.100646,0.048724  /                                   
c factors to convert STO into 12 GTO                                    
      data (stocoeff(12,index),index=1,12)/                             
     &  0.020772,0.032834,0.049904,0.072474,0.100549,                   
     &  0.131966,0.159730,0.169464,0.143624,0.082581,                   
     &  0.024025,0.001897  /                                            
      data (stoexp(12,index),index=1,12)/                               
     & 813.469054,149.220649,41.795981,14.402813,5.650086,              
     & 2.427297,1.116125,0.541102,0.273581,0.142917,                    
     & 0.076222,0.040309  /                                             
c factors to convert STO into 15 GTO                                    
      data (stocoeff(15,index),index=1,15)/                             
     &  0.008428,0.013337,0.020344,0.029831,0.042355,0.058519,0.078820, 
     &  0.103134,0.129253,0.150272,0.152837,0.123095,0.066428,0.017917, 
     &  0.001299/                                                       
      data (stoexp(15,index),index=1,15)/                               
     &  4943.800944,906.886649,254.017045,87.530509,34.327684,          
     &  14.730750,6.751351,3.248735,1.620678,0.831025,0.435907,0.233351,
     &  0.127172,0.070064,0.038035/           
C  End by Bo Wang, 6/3/2011 

      write(eec,*) ee                                                   !0516HL12 THIS BLOCK OF CODE
      estrt = 1                                                         !0516HL12 WAS MOVED UP FROM
      call fchar(eec,estrt,ierr)                                        !0516HL12 A LATER PORTION
      ebeg = estrt                                                      !0516HL12
      call fspace(eec,estrt,ierr)                                       !0516HL12
      eend = estrt                                                      !0516HL12

      write(temp2,*) fn

C  make name of input file equal to the fragment number

      tstrt = 1
      call fchar(temp2,tstrt,ierr)
      tbeg = tstrt      
      call fspace(temp2,tstrt,ierr)
      tend = tstrt - 1
      infile = temp2(tbeg:tend)//'_'//eec(ebeg:eend-1)//'.g09'          !0516HL12 changed '.g09' to '_'//eec(ebeg:eend-1)//'.g09'
      chkfl  = temp2(tbeg:tend)//'_'//eec(ebeg:eend-1)//'.FChk'         !0516HL12
      len = tend - tbeg + 5
c
c Added by Hai Lin, 5/11/2009
c
      mminfile = 'mm'//temp2(tbeg:tend)//'_'//eec(ebeg:eend-1)//'.g09'  !0516HL12 changed '.g09' to '_'//eec(ebeg:eend-1)//'.g09'


c debug
c      write(*,*) 'mminfile = ', mminfile
c
c End by Hai Lin, 5/11/2009
c
c MOVED BLOCK OF CODE UP                                        !0516HL12
c
c Added by Hai Lin, 5/11/2009
c 
c   This is to figure out how many qm atoms
c   If the # of qmatoms = # natoms, we can not use oniom input, we use normal input.
c 
      itotalqm = 0
      do i = 1, 3
        if (tfid(i) .ne. 0) then
          call ggeom(tfid(i),geom,fragid,asym,afrag,fgeom)
          do j = 1, afrag(tfid(i))
            itotalqm = itotalqm + 1
          end do
        end if
      end do
      if (itotalqm .eq. natms) then
        inormal = 1
      else
        if (lscreen .ne. 0) then            !0603BW11 decide if to use the screened charges
          inormal = 2
        else
          inormal = 0
        endif
      endif
c
c End by Hai Lin, 5/11/2009
c
C  Add by Hannah Leverentz, 3/9/2011
c 
c  Store the total number of atoms in the fragment (itotalqm) as
c  a character variable (ctotalqm) for later use:
c 
      write(ctotalqm,*) itotalqm
c 
      tstrt = 1
      call fchar(ctotalqm,tstrt,ierr)
      qbeg = tstrt							! HL110411 bug fix
      call fspace(ctotalqm,tstrt,ierr)
      qend = tstrt - 1							! HL110411 bug fix
c
c  Get the integer code that denotes the type of population analysis
c   to be performed
c
      call chkcpop(cpop,ipop,pfin)
c 
C  End by Hannah Leverentz, 3/9/2011
c
C  if method is CCSD(T) or QCISD(T) change method to get full MP4 energy 
C  as well
c
       if (method(1:7) .eq. 'ccsd(t)') then
            method = 'ccsd(t,e4t)'
       elseif (method(1:8) .eq. 'qcisd(t)') then
            method = 'qcisd(t,e4t)'
       end if
c
c Now open the g09 input file for writing
c
c   For oniom calculations, we need another mm run to get self-energy and derivatives
c   The normal g09 or oniom g09 file is unit 4
c   The mm g09 file is unit 24                              
c 
      open(unit=4,file=infile,form='formatted',status='unknown',
     *      err=1000)
      if (inormal .eq. 0) then
        open(unit=24,file=mminfile,form='formatted',status='unknown',
     *    err=1000)
      else
      endif
c
C Print memory information
c
      write(4,1001) mem
c
c Added by Hai Lin, 5/11/2009
c
      if (inormal .eq. 0) then
        write(24,1001) mem
      endif
c
c End by Hai Lin, 5/11/2009
c
c
C  print route information
C  find the end of the basis set and method specifications
c
c Revised by Hai Lin, 5/11/2009
c
C   This seems to be a bug in mbpac2007-2
c
c      mfin = 0
c      mend = 0
       mfin = 1
       mend = 1
c
c End by Hai Lin, 5/11/2009
c
      call fspace(method,mfin,mend)
      mfin = mfin - 1
      if (bkey(1:3) .eq. 'lib') then
        temp = basis(1)
      elseif (bkey(1:3) .eq. 'gen') then
        temp = bkey(1:3)
      end if
      bfin = 1
      bend = 1
      call fchar(temp,bfin,bend)
      bstr = bfin
      call fspace(temp,bfin,bend)
      bfin = bfin - 1
C  if the user wants to read in a pseudo potential add pseudo=read to the list
C  of keywords added 6/10/09 by Erin Dahlke Speetzen


      if (pseudo .eq. 1 .and. inormal .ne. 2) then                      !0907BW11 
         temp4 = 'pseudo=read '//keywrds
      else 
         temp4 = keywrds
      end if

C end 6/10/09
C
C Revised by Hai Lin, 5/11/2009
C  Revised by Erin Dahlke Speetzen 6/11/09
C
c   write a normal input if inormal=1 
C   write an OINOM & an MM input if inormal=0
C
C  Add by Hannah Leverentz, 3/9/2011
c  
C    Create the variable popkey so that the type of population
C     analysis requested by the user will be performed.
c 
      if ((ipop.ne.0).and.(ipop.ne.3)) then
        pkfin = pfin + 5
        popkey(1:4) = 'pop='
        popkey(5:pkfin) = cpop(1:pfin) // ' '
      else 
        pkfin = 1
        popkey(1:pkfin) = ' '
      end if
c 
C  End by Hannah Leverentz, 3/9/2011
C
      if (inormal .eq. 1 ) then   
        if (icaltype .eq. 0) then
          temp3 = '# '//method(1:mfin)//'/'//temp(bstr:bfin)
C  Add by Hannah Leverentz, 3/9/2011
c    *      //' FChk=All sp '
     *      //' FChk=All '//popkey(1:pkfin)//' sp nosym'   ! HL110624 added nosym keyword
C  End by Hannah Leverentz, 3/9/2011
C     *      //' SCF=(tight,maxcycle=500,xqc)' //' FChk=All sp'
        else if (icaltype .eq. 1) then 
          temp3 = '# '//method(1:mfin)//'/'//temp(bstr:bfin)
C  Add by Hannah Leverentz, 3/9/2011
c    *      //' FChk=All force '
     *      //' FChk=All force nosym '//popkey(1:pkfin)   ! HL110624 added nosym keyword
C  End by Hannah Leverentz, 3/9/2011
C     *      //' SCF=(tight,maxcycle=500,xqc)'//' FChk=All force'
        else if (icaltype .eq. 2) then
          temp3 = '# '//method(1:mfin)//'/'//temp(bstr:bfin)
C  Add by Hannah Leverentz, 3/9/2011
c    *      //' FChk=All freq' 
     *      //' FChk=All freq nosym '//popkey(1:pkfin)   ! HL110624 added nosym keyword
C  End by Hannah Leverentz, 3/9/2011
C     *      //' SCF=(tight,maxcycle=500,xqc)'//' FChk=All freq'
   
        else
        endif
        write(4,'(a80)') temp3
        write(4,1999) temp4
 1999   format('# ', a80)
      elseif (inormal .eq. 0) then
        write(4,2000) keykey, oniomkey(:7),
     *      method(:mfin), '/', temp(:bfin), mmkey(:36), connkey(:33)
        write(24,2010) keykey, ' ', mmkey(2:16), ' ', connkey(:33)
        if (icaltype .eq. 0) then
C revised 6/11/09 EDS
C          write(4,2020)'# ', scfkey, typekey1(:3)
C  Add by Hannah Leverentz, 3/9/2011
c         write(4,2020) '# ',typekey1(:3), temp4
          write(4,2020) '# ',typekey1(:3),popkey(1:pkfin),temp4     
C  End by Hannah Leverentz, 3/9/2011
          write(24,2030) '# ', typekey1(:3)
        else if (icaltype .eq. 1) then
C  Add by Hannah Leverentz, 3/9/2011
c         write(4,2020) '# ', typekey2(:33), temp4
          write(4,2020) '# ', typekey2(:33),popkey(1:pkfin),temp4
C  End by Hannah Leverentz, 3/9/2011
C          write(4,2020) '# ', scfkey, typekey2(:33)
          write(24,2030) '# ', typekey22(:6)
        else if (icaltype .eq. 2) then
C  Add by Hannah Leverentz, 3/9/2011
c         write(4,2020) '# ', typekey3(:5), temp4
          write(4,2020) '# ', typekey33(:40), popkey(1:pkfin), temp4     !0213HL12 changed "typekey3(:5)" to "typekey33(:40)"
C  End by Hannah Leverentz, 3/9/2011
C          write(4,2020) '# ', scfkey, typekey3(:5)
          write(24,2030) '# ', typekey3(:5)
C  end of revisions 6/10/09 EDS
        endif
C  Add by Bo Wang, 6/2/2011 for screened charge use inormal .eq. 2
      elseif (inormal .eq. 2) then                                      
        write(4,2000) keykey,                                       
     *      method(:mfin), '/gen pseudo=read  fchk=all nosym '          !0603BW11 have to use gen and pseudo=read in the keywords
        if (icaltype .eq. 0) then
          write(4,2020) '# ',typekey1(:3),popkey(1:pkfin),temp4
        else if (icaltype .eq. 1) then
          write(4,2020) '# ', typekey22(:6),popkey(1:pkfin),temp4
        else if (icaltype .eq. 2) then
          write(4,2020) '# ', typekey3(:5), popkey(1:pkfin), temp4
        endif                                                         
C  End by Bo Wang, 6/2/2011 
      endif
 2000 format(a4,a,a,a1,a,a,a)
 2010 format(a4,a,a,a,a,a,a)
c  Add by Hannah Leverentz, 3/2/2011
c2020 format(a,a,a)
 2020 format(a,a,a,a)
c  End by Hannah Leverentz, 3/2/2011
 2030 format(a,a)

C
c Write the title
c
      write(4,1002)
      if (inormal .eq. 0) write(24, 1002)
c
C  figure out charge and multiplicity for the smaller cluster
C  for version 1.0 all multiplicities must be the same.
c
      call chgmlt(tfid,cm,chrg,mlt)       
      write(4,*)
      write(4,1012) chrg, mlt
      if (inormal .eq. 0) then
        write(24,*)
        write(24,1012) chrg, mlt
      endif
c
C  write the geometries of the fragment cluster to the file
c
      ltypname = 2
      typname  = qmtypname
      do i = 1, 3
        if (tfid(i) .ne. 0) then
          call ggeom(tfid(i),geom,fragid,asym,afrag,fgeom)
          do j = 1, afrag(tfid(i))
            if (inormal .eq. 1 .or. inormal .eq. 2) then                !0601BW11  inormal=2 use screened charges
c
c the normal qm part
c
              write(4,1014) asym(fragid(tfid(i),j)), fgeom(j,1),
     *             fgeom(j,2), fgeom(j,3)
            else
c
c the oniom & mm qm part (it is okay to have qm atoms in the mm input file.)
c
              lsymbol = 0
              atmsymbol = asym(fragid(tfid(i),j)) 	    	 
              do jj=1, 2
                if (atmsymbol(jj:jj) .ne. ' ') then 
                  lsymbol = lsymbol + 1
                endif 
	      enddo
              write(4,4000)
     *          atmsymbol(:lsymbol), typname(:ltypname), 
     *          oniomqmcharge, fgeom(j,1), fgeom(j,2), fgeom(j,3)
              write(24,4000)
     *          atmsymbol(:lsymbol), typname(:ltypname),
     *          oniomqmcharge, fgeom(j,1), fgeom(j,2), fgeom(j,3)
            endif  
          end do
        end if
      end do

 4000 format (a,'-',a,'-',d10.4,t20,'0 ',3(d16.9,3x),'H')

c
c For oniom & mm input, we add background point charges as MM atoms
c
      if (inormal .eq. 0) then
        mmatmsymbol = chargename
        lsymbol   = 2
        mmtypname   = chargetypname
        ltypname  = 2
        itotalbq   = 0

        do i = 1, nfrg
          if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3))) then
            do j = 1, afrag(i)
              id = fragid(i,j)
c debug
c              write(*,*) 'i= ',i, 'j= ', j, 'id= ', id

              call gbgq(id,bgq,bq,nbgq,asym)
              itotalbq = itotalbq + 1
c
c Note: bq is character, not double precision
c    
              write (4,4100) 
     *          mmatmsymbol(:lsymbol), mmtypname(:ltypname),
     *          bq, geom(id,1), geom(id,2), geom(id,3)
              write (24,4100)
     *          mmatmsymbol(:lsymbol), mmtypname(:ltypname),
     *          bq, geom(id,1), geom(id,2), geom(id,3)
            end do
          else
          end if
        end do
        write(4,*)
        write(24,*)

 4100 format (a,'-',a,'-',a10,t20,'0 ',3(d16.9,3x),'L')

c
c  Connectivity is needed for oniom input
c
        do jj=1, natms 
          write (4,4500) jj
          write (24,4500) jj
        enddo
        write(4,*) 
        write(24,*)

 4500 format (2x,i6,2x,i6,2x,f4.2)

c
c  NonBon key 
c
        write(4,*) mmprmkey
        write(4,*)
        write(24,*) mmprmkey
        write(24,*)
c
c mm input file ends here
c
        write(24,*)

c
c  End of the oniom & mm input
c
C  Add by Bo Wang, 6/1/2011 write the MM atoms as He atoms which no basis sets are used,
C  A pseudopotential is used to substitute the 2 e-

      elseif (inormal .eq. 2) then                         
        do i = 1, nfrg
          if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3))) then
            do j = 1, afrag(i)
             id = fragid(i,j)
c debug
c              write(*,*) 'i= ',i, 'j= ', j, 'id= ', id
             write(4,4110) geom(id,1), geom(id,2), geom(id,3)
            end do
          else
          end if
        enddo
 4110 format ('He    ',3f12.8,'  ')      
C  End by Bo Wang, 6/1/2011 
      else
        write(4,*)
      endif
      if ((inormal .eq. 0 .and. pseudo .eq. 1) 
     &                    .or. (inormal .eq. 2)) then                   !0603BW11 add screened charge scheme
         write(4,*)
      endif
c
c End by Hai Lin, 5/11/2009
c
c
C  if specifying a general basis set write the basis set info here
c
      if (bkey(1:3) .eq. 'gen') then
         do i = 1, nbasis
            write(4,'(a80)') basis(i)
         end do
         write(4,*)
       end if


C  added 6/11/09 by Erin Dahlke Speetzen
C  if using a core potential write the core potential info here

      if (pseudo .eq. 1) then
        do i = 1, ncore
           write(4,'(a80)') core(i)
        end do
      endif

C Add 6/01/2011 by Bo Wang
C using the screened charge method, write the PP
      if (inormal .eq. 2) then                                          !0601BW11 write the pseudopotential to implement the screened charges
        index=itotalqm
        do i = 1, nfrg
           if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3)))    !0615BW11 find the atoms represented by the screened charges
     &                                                       then
             do j = 1, afrag(i)
              id = fragid(i,j)
              index=index+1
              call gbgqs(id,bgq,bq1,nbgq,asym,zeta,nscn,nuc)            !0601BW11 get the charge, zeta, nscreen, nuclear charge here
              maxl=1                                                    !0825BW11 default for max angular momentum
              ngterm=0                                                  !0826BW11 default for addition general terms
              if (mmpseudo .eq. 1) then                                 !0826BW11
                call gmmpp(id,asym,nallmmpp,allmmpp,immpp,mmpp,nmmpp,   !0826BW11
     &                                               ngterm,maxl)       !0825BW11 get the mmpseudopotential,number of lines, and the number of general terms
              endif                                                     !0826BW11
              if (zeta .eq. -1.0) then                                  !0615BW11  charge on atom i is not screened
                nterm=0                                            
              else                                                  
                 acharge=-nscn                           
                 call atomic(asym(id),atnum)                            !0615BW11 find the atomic number of id
                 if (atnum .le. 2) then                                 !0615BW11 H,He
                   nterm=2*ngto1
                   do k=1,nterm
                     if (k .le. ngto1) then
                       exponent(k)=stoexp(ngto1,k)
                       coeff(k)=stocoeff(ngto1,k)
                       npower(k)=1
                     elseif (k.le. 2*ngto1) then
                       exponent(k)=stoexp(ngto1,k-ngto1)
                       coeff(k)=zeta*stocoeff(ngto1,k-ngto1)
                       npower(k)=2
                     endif
                     exponent(k) = exponent(k) * (2.0*zeta)**2
                     coeff(k) = coeff(k) * acharge
                   enddo
                 elseif (atnum .le. 10) then                             !0615BW11 Li~Ne
                   nterm=4*ngto1
                   do k=1,nterm
                     if (k .le. ngto1) then
                       exponent(k)=stoexp(ngto1,k)
                       coeff(k)=stocoeff(ngto1,k)
                       npower(k)=1
                     elseif (k.le. 2*ngto1) then
                       exponent(k)=stoexp(ngto1,k-ngto1)
                       coeff(k)=3.0/2.0*zeta*stocoeff(ngto1,k-ngto1)
                       npower(k)=2
                     elseif (k .le. 3*ngto1) then
                       exponent(k)=stoexp(ngto1,k-2*ngto1)
                       coeff(k)=zeta**2*stocoeff(ngto1,k-2*ngto1)
                       npower(k)=3
                     elseif (k .le. 4*ngto1) then
                       exponent(k)=stoexp(ngto1,k-3*ngto1)
                       coeff(k)=1.0/3.0*zeta**3
     &                                   *stocoeff(ngto1,k-3*ngto1)
                       npower(k)=4
                     endif
                     exponent(k) = exponent(k) * (2.0*zeta)**2
                     coeff(k) = coeff(k) * acharge
                   enddo
                 elseif (atnum .le. 20) then                            !0615BW11 Na~Ar
                   nterm=6*ngto1
                   do k=1,nterm
                     if (k .le. ngto1) then
                       exponent(k)=stoexp(ngto1,k)
                       coeff(k)=stocoeff(ngto1,k)
                       npower(k)=1
                     elseif (k.le. 2*ngto1) then
                       exponent(k)=stoexp(ngto1,k-ngto1)
                       coeff(k)=5.0/3.0*zeta*stocoeff(ngto1,k-ngto1)
                       npower(k)=2
                     elseif (k .le. 3*ngto1) then
                       exponent(k)=stoexp(ngto1,k-2*ngto1)
                       coeff(k)=4.0/3.0*zeta**2
     &                                     *stocoeff(ngto1,k-2*ngto1)
                       npower(k)=3
                     elseif (k .le. 4*ngto1) then                       !0615BW11 K~Kr
                       exponent(k)=stoexp(ngto1,k-3*ngto1)
                       coeff(k)=2.0/3.0*zeta**3
     &                                    *stocoeff(ngto1,k-3*ngto1)
                       npower(k)=4
                     elseif (k .le. 5*ngto1) then
                       exponent(k)=stoexp(ngto1,k-4*ngto1)
                       coeff(k)=2.0/9.0*zeta**4
     &                                    *stocoeff(ngto1,k-4*ngto1)
                       npower(k)=5
                     elseif (k .le. 6*ngto1) then
                       exponent(k)=stoexp(ngto1,k-5*ngto1)
                       coeff(k)=2.0/45.0*zeta**5
     &                                   *stocoeff(ngto1,k-5*ngto1)
                       npower(k)=6
                     endif
                     exponent(k) = exponent(k) * (2.0*zeta)**2
                     coeff(k) = coeff(k) * acharge
                   enddo
                 elseif (atnum .le. 36) then                                !0615BW10 K~Kr
                   nterm=8*ngto1
                   do k=1,nterm
                     if (k .le. ngto1) then
                       exponent(k)=stoexp(ngto1,k)
                       coeff(k)=stocoeff(ngto1,k)
                       npower(k)=1
                     elseif (k.le. 2*ngto1) then
                       exponent(k)=stoexp(ngto1,k-ngto1)
                       coeff(k)=7.0/4.0*zeta*stocoeff(ngto1,k-ngto1)
                       npower(k)=2
                     elseif (k .le. 3*ngto1) then
                       exponent(k)=stoexp(ngto1,k-2*ngto1)
                       coeff(k)=3.0/2.0*zeta**2
     &                                     *stocoeff(ngto1,k-2*ngto1)
                       npower(k)=3
                     elseif (k .le. 4*ngto1) then
                       exponent(k)=stoexp(ngto1,k-3*ngto1)
                       coeff(k)=5.0/6.0*zeta**3
     &                                    *stocoeff(ngto1,k-3*ngto1)
                       npower(k)=4
                     elseif (k .le. 5*ngto1) then
                       exponent(k)=stoexp(ngto1,k-4*ngto1)
                       coeff(k)=1.0/3.0*zeta**4
     &                                    *stocoeff(ngto1,k-4*ngto1)
                       npower(k)=5
                     elseif (k .le. 6*ngto1) then
                       exponent(k)=stoexp(ngto1,k-5*ngto1)
                       coeff(k)=1.0/10.0*zeta**5
     &                                    *stocoeff(ngto1,k-5*ngto1)
                       npower(k)=6
                     elseif (k .le. 7*ngto1) then
                       exponent(k)=stoexp(ngto1,k-6*ngto1)
                       coeff(k)=1.0/45.0*zeta**6
     &                                    *stocoeff(ngto1,k-6*ngto1)
                       npower(k)=7
                     elseif (k .le. 8*ngto1) then
                       exponent(k)=stoexp(ngto1,k-7*ngto1)
                       coeff(k)=1.0/315.0*zeta**7
     &                                   *stocoeff(ngto1,k-7*ngto1)
                       npower(k)=8
                     endif
                     exponent(k) = exponent(k) * (2.0*zeta)**2
                     coeff(k) = coeff(k) * acharge
                   enddo
                 endif
              endif
c
c write the ECP                                                        
c
              write(4,4200) index 
              write(4,4300) maxl                                        !0825BW11
              write(4,4400)
              write(4,4550) nterm+1+ngterm   !0826BW11
              write(4,4600) -bq1
              do k=1, nterm
                write(4,4700) npower(k), exponent(k),coeff(k)
              enddo
              if (immpp .eq. 1) then                                    !0825BW11
                  do k = 1, nmmpp                                       !0825BW11
                    write(4,'(a80)') mmpp(k)                            !0825BW11
                  end do                                                !0825BW11
              else                                                      !0825BW11
                write(4,4800)                                             
              endif							!0825BW11

4200  format (1x,i3,1x,'0')
4300  format (1x,'ECP',i3,1x,'2')                                       !0825BW11                                            
4400  format (1x,'ALL')
4550  format (1x, i3)
4600  format (4x,'1 0.0',3x,d16.8)          !0614BW11 increase to d16.8                            
4700  format  (1x,i3,1x,2(d16.8,3x))        !0614BW11 increase to d16.8                              
4800  format (1x, 'S-part', /, 1x, '1', /, 4x, '1 1.0 0.0')             

             end do
           else
           end if
        end do                                                        
      endif
c    End by Bo Wang 6/1/2011
cx        write(4,*)
cx      end if
C  end of addition
C
C Changed by Hai Lin, 5/11/2009
C 
c   We do not need this part as we switch to ONIOM calculations
C
C  write the coorinates and charges for the background charges
C      do i = 1, nfrg
c       if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3))) then
C         do j = 1, afrag(i) 
C          id = fragid(i,j)
C          call gbgq(id,bgq,bq,nbgq,asym)
C          write(4,1016) geom(id,1), geom(id,2), geom(id,3), bq
C         end do
C       else 
C       end if
C      end do
C
c
C End by Hai Lin, 5/11/2009
C
      write(4,*)
      write(4,*)

      go to 9999

 1000 write(2,1010)  infile
      close(4)
      stop 'wg09 1'
 1001 format('%mem=',a20)
 1002 format(/,'title')
 1003 format(4a,2(3x,a))
 1010 format (3x, 'Error writting input file' , a20)

 1012 format (2(i2))
 1014 format(a3,3(f15.8)) 
 1015 format(3(f15.5),a15)
 1016 format(3(f12.8),'  ',a20)

 9999 close(4)
c
c Added by Hai Lin, 5/11/2009
c     
      if (inormal .eq. 0) close(24)
c
c   Now we pass inormal as the 4th arguement to g09shuttle indicating 
c   if additional mm calculation needed to be done
c 
c      command = 'perl g09shuttle.pl ' // temp2(tbeg:tend)
c     *            //' '// eec(ebeg:eend) // ' 0 >> energy'

      if (icaltype .eq. 0) then 
        ccaltype = '0 '
      else if (icaltype .eq. 1) then
        ccaltype = '1 '
      else if (icaltype .eq. 2) then
        ccaltype = '2 '
      else
      endif

      if (inormal .eq. 0) then
        cnormal = '0 '
      elseif (inormal .eq. 1) then    
        cnormal = '1 '
      elseif (inormal .eq. 2) then                                      !0601BW11
        cnormal = '2 '
      endif

      if (inormal .eq. 2) then                                          !0601BW11 do a MM correction to calculate the interactions between the nuclei and the potentials
        call chgcorr(nfrg,fragid,afrag,tfid,bgq,nbgq,geom,asym,
     *               temp2,tbeg,tend,eec,ebeg,eend)                     !0516HL12 added "eec,ebeg,eend"
      endif

        command = 'perl g09shuttle.pl ' // temp2(tbeg:tend)
     *    //' '// eec(ebeg:eend) //  ccaltype // cnormal // 
C  Add by Hannah Leverentz, 3/9/2011
c    *    ' >> energy'
     *    ' ' // ctotalqm(qbeg:qend) // ' ' // cpop(1:pfin) //          ! HL110411 bug fix
     *    ' ' // cmode(1:1) // ' > ' // temp2(tbeg:tend) // '_' //      ! HL110411 bug fix; 1115HL11 added cmode; 0213HL12 changed from ...
     *    eec(ebeg:eend-1) // '.eemb'                                   ! 0213HL12 ... ">> energy" to ">> x_x.eemb"

C  End by Hannah Leverentz, 3/9/2011
c debug
c      write (6,*) command    
c
c End by Hai Lin, 5/11/2009
c

      call system(command)

      return
      end


C**********************************************************************
C
C    G09OUTE
C
C**********************************************************************
C
C   created : October 18, 2006 by E. E. Dahlke
C   revised : May 11, 2009     by Hai Lin
c             March 2, 2011    by Hannah Leverentz
c    
C   purpose : To pull all energies out of an .eemb file             ! 0621HQ12, corrected purpose
c
c   Revision: See Hai Lin, 5/11/2009
c             See Hannah Leverentz, 3/2/2011
c   Complain: It took me a while to understand this subroutine!
c             It is tricky!
c             1. The index of energy array is for energy types, instead 
c                of number of embedded calculations.
c             2. The return energy is actually the sum of energy for all
c                embedded calculations for a given level.
c             The above treatment saves time, but resulted in difficult 
c             structures to understand, given barely any comments!
c
 
c  Add by Hannah Leverentz, 3/2/2011
c     subroutine g09oute(tof,nf,energy,eflg,etype)
      subroutine g09oute(tof,nf,fragid,frglst,energy,eflg,etype,dip,
     *                   qqm)
c  End by Hannah Leverentz, 3/2/2011

      implicit none
      include 'common.inc'
      integer nf, i, istrt, ierr, j, ii
      integer eflg(maxe)
      character*30 etype(maxe)
      character*2  tof                                  !0213HL12  changed tof from a 6-char variable to a 2-char variable
      character*10 flnm                                 !0213HL12
      character*80  ci                                  !0213HL12
      integer fstrt, fbeg, fend                         !0213HL12
      character*80 string
      double precision energy(maxe), cenergy, senergy
c  Add by Hannah Leverentz, 3/2/2011
      integer ibeg, ifin, fragid(maxfrag,maxapf), frglst(maxlist,3)
      double precision dip(3), tmpdip, qqm(maxat)
      character*80 temp
c  End by Hannah Leverentz, 3/2/2011

C  open the *.eemb file
c debug
c      write(*,*) "tof=", tof, "nf= ", nf

c     open(unit=3,file=tof,status='old',form='formatted',err=9999)     !0213HL12 commented out this line

C  and set all energies to zero, and clear array with the flags
      do i = 1, maxe
            energy(i) = 0
            eflg(i) = 0
      end do

c  Add by Hannah Leverentz, 3/2/2011
c 
C  zero the temporary dipole
      do i = 1, 3
        dip(i) = 0.0d0
      end do
c 
C  zero the QM partial charges array for the current oligomer type
      do i = 1, maxat
        qqm(i) = 0.0d0
      end do
c 
c  End by Hannah Leverentz, 3/2/2011

C  store the data for each data type
	i = 1
      istrt = 1
      do while (i .le. nf)
         write(ci,*) i                                                          !0213HL12
         fstrt = 1                                                              !0213HL12
         call fchar(ci,fstrt,ierr)                                              !0213HL12
         fbeg = fstrt                                                           !0213HL12
         call fspace(ci,fstrt,ierr)                                             !0213HL12
         fend = fstrt - 1                                                       !0213HL12
         flnm = ci(fbeg:fend) // tof // '.eemb'                                 !0213HL12
         open(unit=3,file=flnm,status='old',form='formatted',err=9999)          !0213HL12
         read(3,'(a80)',err=9910,end=9998) string
         call fspace(string,istrt,ierr)
         read(string(1:istrt),*) ii
         read(3,'(a80)',err=9910,end=9998) string
         read(string(30:50),'(f21.10)') senergy
c  revised 6/18/09 by EDs
c	 j = 0
         do while (string(1:12) .ne. 'Total Energy')
C	    j = j + 1
            read(3,'(a80)',err=9910,end=9998) string
C            etype(j) = string(1:30)
            if (string(1:10) .eq. 'SCF Energy') then
               j = 1
               eflg(j) = 0
               etype(j) = string(1:30)
            elseif (string(1:10) .eq. 'MP2 Energy') then
               j = 2
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:10) .eq. 'MP3 Energy') then
               j = 3
               eflg(j) = 1
               etype(j)= string(1:30)
            elseif (string(1:10) .eq. 'MP4 Energy') then		!1115HL11
               j = 4							!1115HL11
               eflg(j) = 1						!1115HL11
               etype(j)= string(1:30)					!1115HL11
            elseif (string(1:11) .eq. 'MP4D Energy') then
               j = 5							!1115HL11 changed from 4 to 5
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:12) .eq. 'MP4DQ Energy') then
               j = 6							!1115HL11 changed from 5 to 6
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:13) .eq. 'MP4SDQ Energy') then
               j = 7							!1115HL11 changed from 6 to 7
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:19) .eq. 'Cluster Energy     ') then       !1115HL11
               j = 8                                                    !1115HL11 
               eflg(j) = 1                                              !1115HL11
               etype(j)= string(1:30)                                   !1115HL11
            elseif (string(1:27) .eq. 
     *                         'Cluster Energy with triples') then      !1115HL11 changed from 'Triples' to 'triples'
               j = 9							!1115HL11 changed from 8 to 9
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:19) .eq. 'Hartree Fock Energy') then       !1115HL11
               j = maxe-1                                               !1115HL11
               eflg(j) = 1                                              !1115HL11
               etype(j) = string(1:30)                                  !1115HL11
            elseif (string(1:12) .eq. 'Total Energy') then
               j = maxe							!1115HL11 changed from j = 9 to j = maxe
               eflg(j) = 1
               etype(j) = string(1:30)
            else 
c              These lines were commented out on Nov. 18, 2011 by Hannah Leverentz
c                because problems were occurring if more than one type of energy
c                given in the output file is not mentioned in the above list. All
c                of these "misc" types of energies were being added together.
c              j = 7					!1115HL11 commented out this line
c              eflg(j) = 1				!1115HL11 commented out this line
c              etype(j) = string(1:30)			!1115HL11 commented out this line
            endif
            read(string(50:71),'(E22.15E2)') cenergy
            energy(j) = energy(j) + cenergy - senergy
C	    eflg(j) = 1
c
c Revised by Hai Lin, 5/11/2009
c
c   Since we use oniom, the scf energy is meaningless and should not be shown
c
c            if (string(1:12) .eq. 'Total Energy') then
C            if (string(1:10) .eq. 'SCF Energy') then
c
c End by Hai Lin, 5/11/2009
c
C                eflg(j) = 0
c            end if
c  end revision 6/18/09 EDS
         end do
c  Add by Hannah Leverentz, 3/2/2011
c 
C  Read in the dipole moments
c 
         read(3,'(a80)',err=9910,end=9998) string
         read(3,'(a80)',err=9910,end=9998) string
C  find the dipole moments
         istrt = 1
         ierr = 0
         do j = 1, 3
             call fchar(string, istrt, ierr)
             ibeg = istrt
             call fspace(string, istrt, ierr)
             ifin = istrt - 1
             temp = string(ibeg:ifin)
             read(unit=temp, fmt=*) tmpdip
             dip(j) = dip(j) + tmpdip
         end do
c 
C  read in the QM partial charges obtained from the oligomer wave function
c 
         call readqqm(ii,frglst,fragid,qqm)
c 
c  End by Hannah Leverentz, 3/2/2011
         close(3)                                               !0213HL12
         i = i + 1
      end do

      return                                                    !0213HL12

 9998 close(3)
c     return                                                    !0213HL12 commented out this line
      stop 'g09cc 3'                                            !0213HL12
 9999 write(2,1900) flnm					!0213HL12 changed 'tof' to 'flnm'
      stop 'g09cc 1'
 1900 format(/3x,'Error : could not open file ', a12)		!0213HL12 changed 'a6' to 'a12'

 9910 write(2,1800) flnm, nf					!0213HL12 changed 'tof' to 'flnm'
      stop 'g09cc 2'
 1800 format(/3x, 'Error: end of file ', a12, ' reached but ', i5,    !0213HL12 changed 'a6' to 'a12'
     *       ' energies not yet read')

      end


C**********************************************************************
C
C    FNDSTRT
C
C**********************************************************************
C
C   created : February 12, 2007 by E. E. Dahlke
C   revised : March 9, 2011 by H. R. Leverentz
C   purpose : to find the last completed energy calculation in a 
C             restart

      subroutine fndstrt(nf,jstrt)

      implicit none

      integer nf, jstrt, i, j, istrt, ierr, ii
      character*80 string, efile

      efile = 'energy'

C  open the *.eemb file

      open(unit=5,file=efile,status='old',form='formatted',err=9999)

C  read in the data looking for the highest fragment number run

      i = 0
      jstrt = 0
      istrt = 1
C  Add by Hannah Leverentz, 3/9/2011
      read(5,'(a80)',end=9998) string
C  End by Hannah Leverentz, 3/9/2011
      do while (i .lt. nf)
C  Add by Hannah Leverentz, 3/9/2011
c        read(5,'(a80)',end=9998) string
C  End by Hannah Leverentz, 3/9/2011
         call fspace(string,istrt,ierr)
         read(string(1:istrt),*) ii
         if (ii .gt. jstrt) then
             jstrt = ii
         end if
         read(5,'(a80)',end=9998) string
C  Add by Hannah Leverentz, 3/9/2011
c        do while (string(1:12) .ne. 'Total Energy')
         do while (string(1:22) .ne. 'Atomic partial charges')
C  End by Hannah Leverentz, 3/9/2011
            read(5,'(a80)',end=9998) string
         end do
C  Add by Hannah Leverentz, 3/9/2011
         read(5,'(a80)',end=9998) string
         do while (string(1:1) .eq. ' ')
           read(5,'(a80)',end=9998) string
         end do 
C  End by Hannah Leverentz, 3/9/2011
         i = i + 1
      end do

 9998 jstrt = jstrt + 1
      close (5)
      return

 9999 write(2,1900)
      stop 'fndstrt 1'

 1900 format (/3x, 'Error could not open file energy')

      end

C******************************************************************************
C
C     READQQM 
C
C******************************************************************************
C
C
C       Created: March 9, 2011 by H. R. Leverentz
C       Revised:
C       Purpose: subroutine to get the sum of the QM wave function-based 
C                partial charge of each atom for a given type of oligomer
C
C       Description: this subroutine reads in the partial charge of each atom
C                    in oligomer "ii" and updates the qqm array to include
C                    those partial charges in a running total that will be
C                    used to estimate the QM charge on each atom in the 
C                    overall system.
C       
C         On input: ii     = the index that labels a certain oligomer in the
C                            frglst array
C                   frglst = a 2D array that stores the monomers that compose
C                            a given oligomer
C                   fragid = a 2D array that stores the labels of the atoms
C                            included in each monomer
C
C        On input and output: qqm = a 1D array that stores the running 
C                                   total of the partial charge on each atom
C                                   in the system as calculated from the QM
C                                   wave functions of a given oligomer type.
C
C
      subroutine readqqm(ii,frglst,fragid,qqm)

      implicit none
      include 'common.inc'

      integer ii, i, j, k, atom, nchrg 
      integer mon(3), nmatm(3)
      integer istrt, ierr, ifin, ibeg
      integer fragid(maxfrag,maxapf), frglst(maxlist,3)
      double precision qqm(maxat), tmpqqm
      character*80 string, temp

      read(3,'(a80)',err=9910,end=9998) string
      read(string(29:38),'(i10)') nchrg

C Get the label of each monomer in the current oligomer and
C  count the number of atoms in each monomer.

      do i=1,3
        mon(i) = frglst(ii,i)
        nmatm(i) = 0
        if (mon(i).ne.0) then
          do j=1,maxapf
            if (fragid(mon(i),j).ne.0) then
              nmatm(i) = nmatm(i) + 1
            end if
          end do
        end if
      end do

C Check to make sure that the sum of atoms equals the 
C  number of charges stored in the *.eemb file.

      if ((sum(nmatm).ne.nchrg).and.(nchrg.ne.0)) then
        write(2,1110) mon(1),mon(2),mon(3),sum(nmatm),nchrg
        stop
      end if

C Go through the .eemb file and get the charge assigned to
C  each atom for the given oligomer type.

      if (nchrg.gt.0) then
        do i = 1, 3
          if (mon(i).ne.0) then
            do j = 1, nmatm(i)
              atom = fragid(mon(i),j)
              read(3,'(a80)',err=9910,end=9998) string
              read(string(2:16),'(f15.8)') tmpqqm
              qqm(atom) = qqm(atom) + tmpqqm
            end do
          end if
        end do
      end if

      return

 1110 format(/3x,"The sum of atoms in monomers",3(1x,i4),
     *       " is ",i7,". This does not equal nchrg: ",i7)

 9910 write(2,1800) 
      stop 'readqqm 1'
 1800 format(/3x, 'Error: end of file reached but charges not yet',
     *            ' read')

 9998 close(3)
      return

      end subroutine readqqm


C******************************************************************************
C
C    CHGCORR 
C
C******************************************************************************
C
C
C       Created: June 2, 2011 by Bo Wang 
C       Revised:
C       Purpose: subroutine to calculate the energy correction  
C
C       Description: this subroutine reads in the coordinates of the QM atoms  
C                    and the screened charges, and calculates the interaction 
C                    energies between the QM nuclei and screened charges(represented by pseudopotential)
C
C         On input:  nfrg         = number of fragments
C                    fragid(i,j)  = the id of ith atom in the jth fragment
C                    afrag(i)     = number of atom in the ith fragment
C                    tfid(i)       = index of the fragment in the i-mer(monomer,dimer,trimer) calculations
C                    bgq(i,1-5)   = symbol, charge, zeta, nscn, and the nuclear charge of the ith atom type
C                    nbgq         = number of atom type
C                    geom         = geometry of atoms in the cluster
C        On  output  enercorr = energy correction for the use of pseudopotential  
C
C
      subroutine chgcorr(nfrg,fragid,afrag,tfid,bgq,nbgq,geom,asym,
     *                    temp2,tbeg,tend,eec,ebeg,eend)                        !0516HL12 added "eec,ebeg,eend"

      implicit none
      include 'common.inc'

      integer i, j, k,l,m,id1,id2,index,atnum,ngto1 
      integer nfrg, fragid(maxfrag,maxapf), afrag(maxfrag),tfid(3),nbgq
      integer tbeg, tend, ebeg, eend                                            !0516HL12 added ",ebeg,eend"
      character*20 bgq(maxat,5)
      character*80 temp2, eec                                                   !0516HL12 added ",eec"
      double precision bq1,bq2,zeta1,zeta2,nscn1,nscn2
      double precision nuc1,nuc2
      double precision fgeom(maxapf,3)
      double precision ratio1,temp,omg1,r,a0,acharge
      double precision stocoeff(15,15),stoexp(15,15) 
      double precision enercorr,dipole,dipolex,dipoley,dipolez

c factors to convert STO into 3 GTO                                     
      data (stocoeff(3,index),index=1,3)/                               
     &  0.107150,0.343808,0.355483 /                                    
      data (stoexp(3,index),index=1,3)/                                 
     &  0.109818,0.405771,2.22766 /                                     
c factors to convert STO into 6 GTO                                     
      data (stocoeff(6,index),index=1,6)/                               
     &  0.021221,0.131906,0.238573,0.241818,0.184113,0.121984 /         
      data (stoexp(6,index),index=1,6)/                                 
     &  0.065110,0.158088,0.407099,1.185060,4.235920,23.103000 /        
c factors to convert STO into 9 GTO                                     
      data (stocoeff(9,index),index=1,9)/                               
     &  0.047713,0.074983,0.111897,0.154809,0.191480,0.195519,          
     &  0.141046,0.053483,0.005656 /                                    
      data (stoexp(9,index),index=1,9)/                                 
     & 153.776713,28.206753,7.899558,2.721478,1.067073,0.457904,        
     &  0.209886,0.100646,0.048724  /                                   
c factors to convert STO into 12 GTO                                    
      data (stocoeff(12,index),index=1,12)/                             
     &  0.020772,0.032834,0.049904,0.072474,0.100549,                   
     &  0.131966,0.159730,0.169464,0.143624,0.082581,                   
     &  0.024025,0.001897  /                                            
      data (stoexp(12,index),index=1,12)/                               
     & 813.469054,149.220649,41.795981,14.402813,5.650086,              
     & 2.427297,1.116125,0.541102,0.273581,0.142917,                    
     & 0.076222,0.040309  /                                             
c factors to convert STO into 15 GTO                                    
      data (stocoeff(15,index),index=1,15)/                             
     &  0.008428,0.013337,0.020344,0.029831,0.042355,0.058519,0.078820, 
     &  0.103134,0.129253,0.150272,0.152837,0.123095,0.066428,0.017917, 
     &  0.001299/                                                       
      data (stoexp(15,index),index=1,15)/                               
     &  4943.800944,906.886649,254.017045,87.530509,34.327684,          
     &  14.730750,6.751351,3.248735,1.620678,0.831025,0.435907,0.233351,
     &  0.127172,0.070064,0.038035/                                     

      parameter(a0=0.5291772)
      enercorr=0.0
      dipole=0.0
      dipolex=0.0
      dipoley=0.0
      dipolez=0.0
      ngto1=3                                                           !expand one slater function to 3 gaussian functions

      do i = 1, 3
        if (tfid(i) .ne. 0) then                                        !tfid(i) is the fragment number for the QM calculation
          do j = 1, afrag(tfid(i))
            id1=fragid(tfid(i),j)
            call gbgqs(id1,bgq,bq1,nbgq,asym,zeta1,nscn1,nuc1)   !0602BW11 get the nuclear charge of QM atoms
            do k = 1, nfrg
             if ((k.ne.tfid(1)).and.(k.ne.tfid(2))
     &                            .and.(k.ne.tfid(3))) then
               do m = 1, afrag(k)
                id2 = fragid(k,m)
                call gbgqs(id2,bgq,bq2,nbgq,asym,zeta2,nscn2,nuc2)     !0601BW11 get the screening information of MM atoms (represented by pseudopotentials)
                r=sqrt((geom(id1,1)-geom(id2,1))**2                     !0602BW11 calculate the distance between QM atom and center of pseudopotential
     &            +(geom(id1,2)-geom(id2,2))**2
     &            +(geom(id1,3)-geom(id2,3))**2)
                call atomic(asym(id2),atnum)
                if (zeta2 .eq. -1.0) then                               !0131BW10 MM charge on atom i is not screened
                  enercorr=enercorr+nuc1*bq2/r*a0                       !0603BW11 enercorr is in unit of hartree 
                else
                  acharge=nscn2        
                  temp=r*zeta2/a0 
                  omg1=0.0                                       
                  do l=1,ngto1                                   
                   omg1=omg1+stocoeff(ngto1,l)                 
     &              *exp(-stoexp(ngto1,l)*(2.0*temp)**2)  
                  enddo                                          
                  if (atnum .le. 2) then                     
                    ratio1=1.0+temp                            
                  elseif (atnum .le. 10) then                
                    ratio1=1.0+3.0/2.0*temp+temp**2          
     &                        +1.0/3.0*temp**3               
                  elseif (atnum .le. 18) then                
                    ratio1=1.0+5.0/3.0*temp+4.0/3.0*temp**2  
     &                  +2.0/3.0*temp**3+2.0/9.0*temp**4   
     &                  +2.0/45.0*temp**5                    
                  elseif (atnum .le. 36) then                
                   ratio1=1.0+7.0/4.0*temp+3.0/2.0*temp**2  
     &                  +5.0/6.0*temp**3+1.0/3.0*temp**4   
     &                  +1.0/10.0*temp**5+1.0/45.0*temp**6 
     &                  +1.0/315.0*temp**7                   
                  endif                                          
                  enercorr=enercorr+nuc1*(bq2+acharge*ratio1*omg1)/r*a0
                endif                                            
               enddo
             endif
            enddo
          enddo
        endif
      enddo
c
c calculate the gradient correction for each QM atom
c
c      do i = 1, 3
c        if (tfid(i) .ne. 0) then                                        !tfid(i) is the fragment number for the QM calculation
c          do j = 1, afrag(tfid(i))
c            id1=fragid(tfid(i),j)
c            call gbgqs(id1,bgq,bq1,nbgq,asym,zeta1,nscn1,nuc1)          !0602BW11 get the nuclear charge of QM atoms
c            do k = 1, nfrg
c             if ((k.ne.tfid(1)).and.(k.ne.tfid(2))
c     &                            .and.(k.ne.tfid(3))) then
c               do m = 1, afrag(k)
c                id2 = fragid(k,m)
c                call gbgqs(id2,bgq,bq2,nbgq,asym,zeta2,nscn2,nuc2)     !0601BW11 get the screening information of MM atoms (represented by pseudopotentials)
c                r=sqrt((geom(id1,1)-geom(id2,1))**2                      !0602BW11 calculate the distance between QM atom and center of pseudopotential
c     &            +(geom(id1,2)-geom(id2,2))**2
c     &            +(geom(id1,3)-geom(id2,3))**2)
c                call atomic(asym(id2),atnum)
c                if (zeta2 .eq. -1.0) then                               !0131BW10 MM charge on atom i is not screened
c                  enercorr=enercorr+nuc1*bq2/r*a0                       !0603BW11 enercorr is in unit of hartree
c                else
c                  acharge=nscn2
c                  vdw0=a0/zeta2
c                  omg3=0.0                                        
c                  do l=1,ngto1                                    
c                    omg3=omg3 - 8.0*stocoeff(ngto1,l)                  !  the derivative of omg3
c     &                  *stoexp(ngto1,l)*r/(vdwd0**2)
c     &                  *exp(-stoexp(ngto1,l)*(2.0*r/vdwd0)**2)   
c                  enddo                                           
c                  scale1=r/vdwd0                                  
c                  if (atomic(i) .le. 2) then                      
c                    ratio3=1.0/vdwd0                              
c                  elseif (atomic(i) .le. 10) then                 
c                    ratio3=(3.0/2.0+2.0*scale1+scale1**2)/vdwd0   
c                  elseif (atomic(i) .le. 18) then                 
c                    ratio3=(5.0/3.0+8.0/3.0*scale1+2.0*scale1**2  
c     &                +8.0/9.0*scale1**3+2.0/9.0*scale1**4)/vdwd0 
c                  elseif (atomic(i) .le. 36) then                 
c                    ratio3=(7.0/4.0+3.0*scale1+5.0/2.0*scale1**2  
c     &               +4.0/3.0*scale1**3+1.0/2.0*scale1**4         
c     &               +2.0/15.0*scale1**5+1.0/45.0*scale1**6)/vdwd0
c                  endif                                           
c                  factor3 = nuc1*acharge*(ratio3*omg1+ratio1*omg3)
c                  denercorr=
c
c                endif
c               enddo
c             endif
c            enddo
c          enddo
c        endif
c      enddo

c      do k = 1, nfrg                                                   !0615BW11 calculated dipoles created by the screened charges
c       if ((k.ne.tfid(1)).and.(k.ne.tfid(2))
c     &                      .and.(k.ne.tfid(3))) then
c         do m = 1, afrag(k)
c           id2 = fragid(k,m)
c           call gbgqs(id2,bgq,bq2,nbgq,asym,zeta2,nscn2,nuc2)          !0601BW11 get the charge, zeta, nscreen, nuclear charge here
c           dipolex=dipolex+bq2*geom(id2,1)
c           dipoley=dipoley+bq2*geom(id2,2)
c           dipolez=dipolez+bq2*geom(id2,3)
c         enddo
c       endif
c      enddo
c      dipole=sqrt(dipolex**2+dipoley**2+dipolez**2)*4.803
c      dipolex=dipolex*4.803
c      dipoley=dipoley*4.803
c      dipolez=dipolez*4.803

      open(unit=24,file='mmcorr'// temp2(tbeg:tend) // '_' //           !0516HL12 added // '_' //
     *      eec(ebeg:eend-1) // '.out', form='formatted',               !0516HL12 eec(ebeg:eend-1)
     *      status='unknown',err=1000)                                  !0516HL12
      write (24,1010) -enercorr
c      write (24,1020) 
c      write (24,1030) -dipolex,-dipoley,-dipolez
      close (24)

1010  format('mm correction = ',f14.8,' Hartree')
1020  format('Dipole Moment:   Debye')
1030  format(3f14.8)

      return
1000  stop 'chgcorr 1' 
      end

c******************
c  atomic
c******************
C
C       Created: June 2, 2011 by Bo Wang 
C       Revised:
C       Purpose: subroutine to get atomic number from the symbol of the type 
C 
C       Description: this subroutine returns the atomic number of the atom
C
C         On input:   string   = name of the atom type, eg 'O1 ' 
C
C        On  output:  atnum  =  atomic number of the atom type
C
      subroutine atomic(symbol,atnum)

      implicit none
      integer atnum,i,chindex
      character*8 symbol,string
      character*2 atmsy,asymbu(103)  
      character*80 case
      
      data (asymbu(i),i=1,103)  /
     *   'H ','HE','LI','BE','B ','C ','N ','O ','F ','NE',
     *   'NA','MG','AL','SI','P ','S ','CL','AR',
     *   'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI','CU',
     *        'ZN','GA','GE','AS','SE','BR','KR',
     *   'RB','SR','Y ','ZR','NB','MO','TC','RU','RH','PD','AG',
     *        'CD','IN','SN','SB','TE','I ','XE',
     *   'CS','BA','LA','CE','PR','ND','PM','SM','EU','GD','TB',
     *        'DY','HO','ER','TM','YB','LU','HF','TA','W ','RE',
     *        'OS','IR','PT','AU','HG','TL','PB','BI','PO','AT','RN',
     *   'FR','RA','AC','TH','PA','U','NP','PU','AM','CM','BK',
     *        'CF','ES','FM','MD','NO','LR'/

      string=symbol
      if (string(2:2) .le. '9' 
     &      .and. string(2:2) .ge. '0') then
         string(2:2)=' '
      elseif (string(2:2) .le. 'z'
     &      .and. string(2:2) .ge. 'a') then
         chindex = ichar(string(2:2)) - 32
         string(2:2) = char(chindex)
      endif
c
      atmsy=string(1:2)
      do i=1, 103
        if (asymbu(i) .eq. atmsy) then
          atnum=i
          exit
        endif
      enddo
      return
      end


C******************************************************************************
C
C     SETUPHF  
C
C******************************************************************************
C
C
C       Created: Nov. 15, 2011 by H. R. Leverentz
C       Revised:
C       Purpose: to set up the full-system hartree fock (HF) calculation
C                that is needed to run an EE-MB-CE calculation.
C
C       Description: 
C
      subroutine setuphf(natms,method,basis,nbasis,bkey,cm,asym,geom,
     *                   icaltype,keywrds,pseudo,core,ncore,mem)

      implicit none
      include 'common.inc'

      integer  natms,nbasis,icaltype,pseudo,ncore
      integer  cm(maxfrag,2)
      integer  mfin,mend,bfin,bend,bstr,charge,mult
      integer  nfin,nend,nstr
      integer  i,j,k,l,m,n

      character*80 basis(1000),keywrds,core(1000)
      character*80 temp,temp3,temp4,command
      character*20 bkey,method,infile,mem,cnatms
      character*3  ccaltype

C  set the Gaussian input file name to "fullhf.g09":

       infile = 'fullhf_1.g09'          !0516HL12 changed "fullhf.g09" to "fullhf_1.g09"

C  if method is CCSD(T) or QCISD(T) change method to get full MP4 energy
C  as well
c
       if (method(1:7) .eq. 'ccsd(t)') then
            method = 'ccsd(t,e4t)'
       elseif (method(1:8) .eq. 'qcisd(t)') then
            method = 'qcisd(t,e4t)'
       end if

c
c Now open the g09 input file for writing
c
      open(unit=4,file=infile,form='formatted',status='unknown',
     *      err=1000)
c
c Print memory information
c
      write(4,1001) mem
c
C  print route information
C  find the end of the basis set and method specifications
c
       mfin = 1
       mend = 1
c
      call fspace(method,mfin,mend)
      mfin = mfin - 1
      if (bkey(1:3) .eq. 'lib') then
        temp = basis(1)
      elseif (bkey(1:3) .eq. 'gen') then
        temp = bkey(1:3)
      end if
      bfin = 1
      bend = 1
      call fchar(temp,bfin,bend)
      bstr = bfin
      call fspace(temp,bfin,bend)
      bfin = bfin - 1
c
c  if the user wants to read in a pseudo potential add pseudo=read to the list
c  of keywords 
c
      if (pseudo .eq. 1) then   
         temp4 = 'pseudo=read '//keywrds
      else
         temp4 = keywrds
      end if
c
      if (icaltype .eq. 0) then
        temp3 = '# hf/'//temp(bstr:bfin)//' FChk=All sp nosym' 
      endif 
      write(4,'(a80)') temp3     
      write(4,1999) temp4         
      write(4,*)
c
c  Write the title
c
      write(4,1002)
c 
c  Figure out the charge and multiplicity of the large system.
c    NOTICE that the program currently assumes that all fragment
c    multiplicities are the same as one another and as that of
c    the entire system.
c
      charge = 0
      do i=1,maxfrag
        charge = charge + cm(i,1)
      end do
 
      mult = cm(1,2)                   ! See NOTICE above

      write(4,*)
      write(4,1012) charge,mult
c
c  Write the geometry of the entire system to the Gaussian input file
c
      do i=1,natms
        write(4,1014) asym(i), geom(i,1), geom(i,2), geom(i,3)
      end do
      write(4,*)
c
c  if specifying a general basis set write the basis set info here
c
      if (bkey(1:3) .eq. 'gen') then
         do i = 1, nbasis
            write(4,'(a80)') basis(i)
         end do
         write(4,*)
       end if
c
c  if using a core potential write the core potential info here
c
      if (pseudo .eq. 1) then
        do i = 1, ncore
           write(4,'(a80)') core(i)
        end do
        write(4,*)
      endif
      close (4)
c
c  store the calculation type as a character variable 
c   (0 => energy, 1 => gradient, 2 => hessian)
c
      if (icaltype .eq. 0) then
        ccaltype = '0 '
      else if (icaltype .eq. 1) then
        ccaltype = '1 '
      else if (icaltype .eq. 2) then
        ccaltype = '2 '
      else
      endif
c
c  store the number of atoms in the system as a character variable
c
      write(cnatms,*) natms
      nfin = 1
      nend = 1
      call fchar(cnatms,nfin,nend)
      nstr = nfin
      call fspace(cnatms,nfin,nend)
      nfin = nfin -1
c
c  call the g09shuttle.pl script to run the full HF calculation
c
      command = 'perl g09shuttle.pl fullhf 1 '// ccaltype // '1 '
     *          // cnatms(nstr:nfin) // ' none 1 >> fullhf_1.txt'       !0516HL12 changed "fullhf_1.txt to fullhf_1.txt"
   
      call system(command)

      go to 9999

 1000 write(2,1010)  infile
      close(4)
      stop 'setuphf 1'

 1001 format('%mem=',a20)
 1002 format('HF calculation on entire system for EE-MB-CE')
 1010 format (3x, 'Error writting input file' , a20)
 1012 format (2(i2))
 1014 format(a3,3(f15.8))
 1999 format('# ', a80)

 9999 continue 
      return
      
      end subroutine setuphf


C******************************************************************************
C
C     GETFHFE
C
C******************************************************************************
C
C
C       Created: Nov. 16, 2011 by H. R. Leverentz
C       Revised: May 4, 2012 by H. R. Leverentz (changed every occurrence of
C                "fullhf.txt" to "fullhf_1.txt")
C       Purpose: to get the full-system Hartree Fock energy from the file
C                "fullhf_1.txt" in order to run an EE-MB-CE calculation.
C
C       Description: 
C
C              on input:  ehf is undefined
C              on output: ehf is equal to the HF energy of the entire system
C
      subroutine getfhfe(ehf)

      implicit none
      include 'common.inc'

      character*80 string
      double precision ehf

c  zero the Hartree Fock energy

      ehf = 0

c  open the "fullhf_1.txt" file and get the HF energy from it

      open(unit=3,file='fullhf_1.txt',status='old',form='formatted',
     *     err=9999)

      do while (string(1:10).ne.'SCF Energy')
        read(3,'(a80)',err=9910,end=9910) string
      end do

      read(string(50:71),'(E22.15E2)') ehf

 9998 close(3)

      return

 9910 write(2,1800) 
      stop 'getfhfe 2'
 1800 format(/3x, 'Error: end of file fullhf_1.txt reached but the full',
     *            ' HF energy not yet read.')

 9999 write(2,1900) 
      stop 'getfhfe 1'
 1900 format(/3x,'Error : could not open file fullhf_1.txt')

      end subroutine getfhfe

C******************************************************************************
C
C     CALCMBCE 
C
C******************************************************************************
C
C
C       Created: Nov. 16, 2011 by H. R. Leverentz
C       Revised:
C       Purpose: this subroutine calculates the EE-PA-CE and EE-3B-CE 
C                approximations of the system's energy.
C
C       Description: this subroutine calculates the 1B, PA, and 3B
C                    approximations of the full system's correlation
C                    energy and then adds those to the full system's
C                    Hartree Fock (HF) energy to obtain the EE-PA-CE
C                    and EE-3B-CE approximations of the full system's
C                    total energy.  To see the equations that define
C                    the EE-MB-CE approximations of the system's 
C                    energy, read 
C                       Dahlke, E.E., et al. JCTC 2008, 4, 33-41.
C            
C            input variables
C                    eemb: an integer that = 2 if an EE-PA-CE calculation
C                          is requested and that = 3 if an EE-3B-CE 
C                          calculation is requested.
C                    etype: an array that tells each type of energy that
C                          has been calculated; for example, etype(2) = 
C                          "MP2 Energy", etype(3) = "MP3 Energy", etc.
C                    eflg: an array that tells whether or not a certain
C                          type of energy has been calculated.  For 
C                          example, if eflg(2) = 1, this means the MP2
C                          energies of the monomers, dimers, etc. has been
C                          calculated, but if eflg(2) = 0, then the MP2 
C                          energies have not been calculated.  If eflg(3) = 1,
C                          then the MP3 energies have been calculated.  See the 
C                          g09oute subroutine to see which eflg array index
C                          corresponds to each energy type.
C                     ehf: the HF energy of the full system
C                     v1:  an array containing the 1-body term of the MB 
C                          expansion of the system's energy at each level
C                          of correlated wave function theory possible.  The
C                          indices of the V1 array match those of the eflg
C                          array (that is, v1(2) contains the MP2 1-body term,
C                          v1(3) contains the MP3 1-body term, etc.)
C                     v2:  an array containing the 2-body term of the MB 
C                          expansion of the system's energy at each level of
C                          theory.
C                     v3:  an array containing the 3-body term of the MB 
C                          expansion of the system's energy at each level of 
C                          theory.
C
C            output variables
C                     v1ce: the 1-body term of the MB expansion of the system's
C                           correlation energy 
C                     v2ce: the 2-body term of the MB expansion of the system's
C                           correlation energy
C                     v3ce: the 3-body term of the MB expansion of the system's
C                           correlation energy
C                     eepace: the EE-PA-CE approximation of the full system's 
C                           total energy
C                     ee3bce: the EE-3B-CE approximation of the full system's 
C                           total energy
C
      subroutine calcmbce(eemb,etype,eflg,ehf,v1,v2,v3,v1ce,v2ce,v3ce,
     *                    eepace,ee3bce)

      implicit none
      include 'common.inc'

      integer  eflg(maxe), i, j, k, eemb
      double precision  ehf, v1(maxe), v2(maxe), v3(maxe)
      double precision  v1ce(maxe), v2ce(maxe), v3ce(maxe)
      double precision  eepace(maxe), ee3bce(maxe)
      character*30 etype(maxe)

c  zero the output variables

      v1ce = 0
      v2ce = 0
      v3ce = 0
      eepace = 0
      ee3bce = 0

c  calculate the EE-MB-CE energies

      do i = 2, maxe-2
        if (eflg(i) .eq. 1) then
          v1ce(i) = v1(i) - v1(maxe-1)
          v2ce(i) = v2(i) - v2(maxe-1)
          v3ce(i) = v3(i) - v3(maxe-1)
          eepace(i) = ehf + v1ce(i) + v2ce(i)
          ee3bce(i) = eepace(i) + v3ce(i)
c          write(2,*) "i,v1ce,v2ce,v3ce,eepace,ee3bce",
c     *                i,v1ce(i),v2ce(i),v3ce(i),eepace(i),ee3bce(i)
        end if
      end do

c  print the results to the eemb.out file (unit=2)

      write (2,1100)
      write (2,1200) ehf
      write (2,1250)

c     print the V1-CE, V2-CE, and V3-CE values (the 1-body, 2-body, and 3-body 
c      correlation energy terms, respectively)

      if (eemb .eq. 2) then
        write (2,1300)
        do i = 2, maxe-2
          if (eflg(i) .eq. 1) then
            write (2,1350) etype(i),v1ce(i),v2ce(i)
          endif
        end do
      elseif (eemb. eq. 3) then
        write (2,1400)
        do i = 2, maxe-2
          if (eflg(i) .eq. 1) then
            write (2,1450) etype(i),v1ce(i),v2ce(i),v3ce(i)
          endif
        end do
      end if

c     print the EE-PA-CE and, if requested, the EE-3B-CE values

      if (eemb .eq. 2) then
        write (2,1500)
        do i = 2, maxe-2
          if (eflg(i) .eq. 1) then
            write (2,1550) etype(i),eepace(i)
          endif
        end do
      elseif (eemb. eq. 3) then
        write (2,1600)
        do i = 2, maxe-2
          if (eflg(i) .eq. 1) then
            write (2,1650) etype(i),eepace(i),ee3bce(i)
          endif
        end do
      end if

      write (2,1700)

      return

 1100 format(/,/3x,73('-'),/29x,'EE-MB-CE RESULTS',/3x,73('-'))
 1200 format(/3x,'Hartree Fock Energy of the entire system: ',
     *              f20.10,' Hartrees')
 1250 format(/3x,"KEY:  V1-CE  =  the 1-body term in the expansion ",
     *           "of the system's",/19x,"correlation energy",
     *     /,/9x,"V2-CE  =  the 2-body term in the expansion of the",
     *           " system's",/19x,"correlation energy")
 1300 format(/3x,'Type of Energy',23x,'V1-CE (Hartrees)',4x,
     *           'V2-CE (Hartrees)',/3x,'--------------',22x,
     *           '-----------------',3x,'-----------------')
 1350 format(3x,a30,1x,f19.10,2x,f19.10)
 1400 format(/3x,'Type of Energy',23x,'V1-CE (Hartrees)',4x,
     *           'V2-CE (Hartrees)',4x,'V3-CE (Hartrees)',
     *       /3x,'--------------',22x,'-----------------',3x,
     *           '-----------------',3x,'-----------------')
 1450 format(3x,a30,1x,f19.10,2x,f19.10,1x,f19.10)
 1500 format(/,/3x,'Type of Energy',17x,'EE-PA-CE Energy (Hartrees)',
     *         /3x,'--------------',17x,'--------------------------')   
 1550 format(3x,a30,1x,f19.10)
 1600 format(/,/3x,'Type of Energy',17x,'EE-PA-CE Energy (Hartrees)',
     *             4x,'EE-3B-CE Energy (Hartrees)',/3x,
     *             '--------------',17x,'--------------------------',
     *             4x,'--------------------------')
 1650 format(3x,a30,1x,f19.10,13x,f19.10)
 1700 format(/,/3x,'END OF EE-MB-CE RESULTS',/3x,73('-'))

      end subroutine calcmbce


C**********************************************************************
C
C    FNDSTRT2S
C
C**********************************************************************
C
C   created : February 6, 2012 by H. R. Leverentz
C   revised : 
C   purpose : to find the last completed energy calculation in a
C             restart  
C   description: nf, tout, tstrt, and tfin are input variables.
C                  nf = the number of fragments of the given type
C                       (i.e., the number of monomers, dimers, or
C                       trimers)
C                  tout = a character variable that is "1" for 
C                         monomers, "2" for dimers, and "3" for
C                         trimers
C                  tstrt and tfin = integers that denote the 
C                         starting and ending locations of the 
C                         non-space character(s) stored in tout
C                jstrt is modified during this subroutine
C                  jstrt = the fragment at which the calculation 
C                          must be restarted


      subroutine fndstrt2s(nf,jstrt,tout,tstrt,tfin)

      implicit none
      include 'common.inc'

      integer nf, i, j, istrt, ierr, ii, jstrt
      integer tstrt,tfin,fstrt,fbeg,fend
      integer fstat
      integer donef(maxlist)
      character*80 string, efile, ci
      character*30 tout


C  read in the data and find out which fragments have been run.
C  donef(i) = 1 if the calculation for fragment i is done
C  donef(i) = 0 if the calculation for fragment i is not done
C  nftc is the number of fragments that have to be completed

      i = 1
      istrt = 1
      jstrt = 0
      do while (i .le. nf)
         write(ci,*) i
         fstrt = 1
         call fchar(ci,fstrt,ierr)
         fbeg = fstrt
         call fspace(ci,fstrt,ierr)
         fend = fstrt - 1
         efile = ci(fbeg:fend) // "_" // tout(tstrt:tfin) // ".eemb"
         open(unit=5,file=efile,status='old',form='formatted',
     *        iostat=fstat)
         if (fstat.eq.0) then
           read(5,'(a80)',end=9998) string
           call fspace(string,istrt,ierr)
           read(string(1:istrt),*) ii
           if (ii. gt. jstrt) then
             jstrt = ii
           endif
         else  
            jstrt = i
            i = nf
         endif
         close(5)
         i = i + 1
      end do

      return

 9998 close(5)
      write(2,1900) efile
      stop 'fndstrt2 1'
 1900 format(/3x,'Error: file ',a80,' is empty')

      end subroutine fndstrt2s
                                                                          
C**********************************************************************
C
C    FNDSTRT3
C
C**********************************************************************
C
C   created : May 3, 2012 by H. R. Leverentz
C   revised : 
C   purpose : to find the last completed energy calculation in a
C             restart  
C   description: ijob, nfg, tout, tstrt, and tfin are input variables.
C                  ijob = the integer that labels this particular "job";
C                         it is the index of this fragment in the joblist
C                         array
C                  nfg  = the integer label of this particular fragment of a 
C                         given type
C                  tout = a character variable that is "1" for 
C                         monomers, "2" for dimers, and "3" for
C                         trimers
C                  tstrt and tfin = integers that denote the 
C                         starting and ending locations of the 
C                         non-space character(s) stored in tout
C                donef and nftc are altered during the course of
C                 this subroutine.
C                  donef = an array that contains a "1" if the 
C                          given fragment has already been calculated,
C                          and "0" if it has not.
C                  nftc = the number of fragments of this type that 
C                         remain to be calculated.


      subroutine fndstrt3(ijob,nfg,donef,nftc,tout,tstrt,tfin)

      implicit none
      include 'common.inc'

      integer ijob, nfg, i, j, istrt, ierr, ii, nftc
      integer tstrt,tfin,fstrt,fbeg,fend
      integer ctst,ctbg,cten                                    !0523HL12
      integer fstat
      integer donef(maxlist)
      character*80 string, efile, ci, ctemp                     !0523HL12 added ", ctemp"
      character*30 tout


C  read in the data and find out which fragments have been run.
C  donef(i) = 1 if the calculation for fragment i is done
C  donef(i) = 0 if the calculation for fragment i is not done
C  nftc is the number of fragments that have to be completed

      if (nfg.eq.-1) then                                       !0523HL12
        efile = 'fullhf_1.txt'                                  !0523HL12
      else                                                      !0523HL12
        write(ci,*) nfg
        fstrt = 1
        call fchar(ci,fstrt,ierr)
        fbeg = fstrt
        call fspace(ci,fstrt,ierr)
        fend = fstrt - 1
        efile = ci(fbeg:fend) // "_" // tout(tstrt:tfin) // ".eemb"
      endif                                                     !0523HL12
      open(unit=5,file=efile,status='old',form='formatted',
     *     iostat=fstat)
      if (fstat.eq.0) then
        read(5,'(a80)',end=9998) string
        if (nfg.eq.-1) then                                     !0523HL12
          ctst = 1                                              !0523HL12
          call fchar(string,ctst,ierr)                          !0523HL12
          ctbg = ctst                                           !0523HL12
          call fspace(string,ctst,ierr)                         !0523HL12
          cten = ctst-1                                         !0523HL12
          if (string(ctbg:cten).eq.'fullhf') then               !0523HL12
            donef(ijob) = 1                                     !0523HL12
            nftc = nftc - 1                                     !0523HL12
          else                                                  !0523HL12
            donef(ijob) = 0                                     !0523HL12
          endif                                                 !0523HL12
        else                                                    !0523HL12
          read(string,*) ii
          if (ii.eq.nfg) then
            donef(ijob) = 1
            nftc = nftc - 1
          else		
            donef(ijob) = 0
          endif		
        endif                                                   !0523HL12
      else
        donef(ijob) = 0
      endif
      close(5)

      return

 9998 close(5)
      write(2,1900) efile
      stop 'fndstrt3 1'
 1900 format(/3x,'Error: file ',a80,' is empty')

      end subroutine fndstrt3
                                                                         
 
C**********************************************************************,
C
C  UPDTJOBS
C
C**********************************************************************
      subroutine updtjobs(rstrt,ityp,nf,frglst,njtc,tout,tstrt,tfin,
     *                    imrk,joblist,donef)

C  Created:     May 3, 2012 by Hannah Leverentz   
C  Revised:     
C  Purpose:     to update the joblist array, which has the following form
C               for a 3-monomer system (as an example):
C
C                          1  2  3  4  5
C                          -  -  -  -  -
C                       1| 1  1  1  0  0
C                       2| 1  2  2  0  0
C                       3| 1  3  3  0  0
C                       4| 2  1  1  2  0
C                       5| 2  2  1  3  0
C                       6| 2  3  2  3  0
C                       7| 3  1  1  2  3
C
C                Column 1 contains a 1 if the last three columns in the 
C                given row describe a monomer, a 2 if the last three 
C                columns give the labels of monomers that comprise a 
C                specific dimer, and a 3 if the last three columns give
C                the labels of monomers that comprise a specific trimer.
C                Column 2 labels a specific monomer, dimer, or trimer.
C  
C                In the example above, focus on row 5:
C                       5| 2  2   1  3  0
C                The first 2 means that a dimer is being described.
C                The second 2 means that dimer #2 is being described.
C                "1 3 0" means that monomers 1 and 3 comprise dimer #2.
C
C  Description: input variables are rstrt (which =1 if this is a restarted
C               calculation and 0 otherwise), ityp (which =1 for 
C               monomer, 2 for dimer, or 3 for trimer), nf (the total 
C               number of fragments of type ityp), frglst (a 2D array 
C               that contains the labels of the monomers that comprise 
C               each oligomer of type ityp), tout (the "_i.eemb" part 
C               of the filename), tstrt and tfin (integers that denote 
C               the starting and ending locations of the non-space 
C               characters stored in tout).
C               Variables that are both input and output variables because 
C               they are updated during the course of this subroutine are
C               njtc (the number of jobs to calculate), imrk (which 
C               marks the position of the last filled row in the 
C               joblist array) and joblist (a 2D array whose form is
C               described above in the purpose section).
C
C  Variables defined here:

      implicit none
      include 'common.inc'

      integer ityp, nf, imrk, i, j, k, l, m, n
      integer ifrst, ilast
      integer frglst(maxlist,3), joblist(maxjob,5)
      integer donef(maxjob),njtc,nftc,tstrt,tfin,rstrt	
      character*30 tout				

      ifrst = imrk+1
      ilast = imrk+nf

      n = 1
      nftc = nf				
      do i=ifrst,ilast
        joblist(i,1) = ityp
        joblist(i,2) = n
        do j = 1,3 
          joblist(i,j+2) = frglst(n,j)
        end do
        if (rstrt.ne.0) then	
          call fndstrt3(i,n,donef,nftc,tout,tstrt,tfin)	
        endif					
        n = n+1
      end do

      njtc = njtc + nftc		
      imrk = ilast
      
      end subroutine updtjobs
















c******************************************************************************
C
C      EMOLP
C
c******************************************************************************
C
C     created : Jun 18, 2012 by H Qi
c     purpose : write the molpro input file

c     based on the eg09 subroutine



      subroutine emolp(natms,fragid,cm,afrag,nfrg,basis,title,bgq,
     *                method,geom,asym,tfid,fn,nbasis,mem,nbgq,ee,bkey,
     *                icaltype,keywrds,core,pseudo,ncore,cpop,lscreen,
     *                allmmpp,nallmmpp,mmpseudo,cmode)
      implicit none
      include 'common.inc'

      integer   natms,  nfrg, fn, fn2, nbasis, len, bstr, ncore, pseudo
      integer   mfin, mend, bfin, bend, tbeg, tend,tstrt,ierr
      integer   chrg, mlt, nbgq, flg, id,ee, estrt, eend, ebeg
      integer   i,j
      integer      lsymbol,  ltypname 
      integer      itotalbq, itotalqm, itotal
      integer      inormal,  icaltype
      integer      jj, kk
      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer   tfid(3), istrt, iend, strt(3), end(3)
      character*80 basis(1000), title(5), temp, command, temp2, eec
      character*80 temp3, core(1000), keywrds, temp4
      character*20 bgq(maxat,5), method, infile, name(3),mem, bq  
      character*20 chkfl, bkey
      character*1  cmode                                     
      character*2  atmsymbol, typname
      character*2  mmatmsymbol, mmtypname
      character*3  ccaltype, cnormal
      character*22 latfile
      double precision fgeom(maxapf,3)
      character*20 ctotalqm
      character*20 cpop,popkey
      integer ipop,pfin,pkfin
      integer qbeg,qend
C  variables used for the screened charges; left because some subroutines require them
      integer lscreen                                                   
      integer npower(50)
      double precision zeta,nscn,nuc,acharge
      double precision exponent(50),coeff(50)
      double precision stoexp(15,15),stocoeff(15,15)
      double precision bq1                                              !bq1 is double precision
      integer k,atnum,index,nterm,ngto1                             
      integer ngterm,immpp,nmmpp,nallmmpp,mmpseudo,maxl              !0825BW11
      character*80 mmpp(50)                                          !0825BW11 the mm pseudopotentials for the charge
      character*80 allmmpp(1000)                                     !0825BW11 all mm pseudopotentials
 
      integer mmb, mme, mms

      ngto1=3                                       

      write(eec,*) ee                                                  
      estrt = 1                                                        
      call fchar(eec,estrt,ierr)                                      
      ebeg = estrt                                                      
      call fspace(eec,estrt,ierr)                                  
      eend = estrt                                                   

      write(temp2,*) fn

C  make name of input file equal to the fragment number

      tstrt = 1
      call fchar(temp2,tstrt,ierr)
      tbeg = tstrt      
      call fspace(temp2,tstrt,ierr)
      tend = tstrt - 1
      infile = temp2(tbeg:tend)//'_'//eec(ebeg:eend-1)//'.inp'        
      len = tend - tbeg + 5
      latfile = temp2(tbeg:tend)//'_'//eec(ebeg:eend-1)//'.lat' 

c 
c   This is to figure out how many qm atoms
c   If the # of qmatoms = # natoms, we can not use lattice input, we use normal input.
c 

c   !!! Currently not using any screened charges in molpro, so inormal can only be 0 or 1
      itotalqm = 0
      do i = 1, 3
        if (tfid(i) .ne. 0) then
          call ggeom(tfid(i),geom,fragid,asym,afrag,fgeom)
          do j = 1, afrag(tfid(i))
            itotalqm = itotalqm + 1
          end do
        end if
      end do
      if (itotalqm .eq. natms) then
        inormal = 1
      else
         inormal = 0
      endif

c  Store the total number of atoms in the fragment (itotalqm) as
c  a character variable (ctotalqm) for later use:
c 
      write(ctotalqm,*) itotalqm
c 
      tstrt = 1
      call fchar(ctotalqm,tstrt,ierr)
      qbeg = tstrt							! HL110411 bug fix
      call fspace(ctotalqm,tstrt,ierr)
      qend = tstrt - 1							! HL110411 bug fix
c
c  Get the integer code that denotes the type of population analysis
c   to be performed
c
      call chkcpop(cpop,ipop,pfin)
c 
c Now open the input file for writing
c
c   The normal file is unit 4
c   The lattice file is unit 24                              

c 
      open(unit=4,file=infile,form='formatted',status='unknown',
     *      err=1000)
      if (inormal .eq. 0) then
        open(unit=24,file=latfile,form='formatted',status='unknown',
     *    err=1000)
      else
      endif
c
C Print memory information
c
      mms=1
      mmb=1
      mme=1
      call fchar(mem,mms,ierr)
      mmb=mms
      call fspace(mem,mms,ierr)
      mme=mms-3                       ! assumes input has two characters at the end of the mem string

      write(4,1001) mem(mmb:mme), mem(mme+1:mme+2)       ! for molpro, make sure mem is ONLY in words

      mfin = 1
      mend = 1

      call fspace(method,mfin,mend)
      mfin = mfin - 1

c
c  Basis set stuff
c
      if (bkey(1:3) .eq. 'lib') then
        temp = basis(1)
      elseif (bkey(1:3) .eq. 'gen') then
        temp = bkey(1:3)
      end if
      bfin = 1
      bend = 1
      call fchar(temp,bfin,bend)
      bstr = bfin
      call fspace(temp,bfin,bend)
      bfin = bfin - 1

C
c   write a normal input if inormal=1 
C   write a lattice input if inormal=0
C

C
c Write the title
c
      write(4,'(a11)') 'geomtyp=xyz'
      if (inormal .eq. 0) then 
         write(24, '(a18)') 'Background charges'
         write(24, '(i5)') natms-itotalqm
      endif
c
C  figure out charge and multiplicity for the smaller cluster
C  for version 1.0 all multiplicities must be the same.
c
      call chgmlt(tfid,cm,chrg,mlt)       

c
C  write the geometries of the fragment cluster to the file
c
      write(4,8000)
      write(4,'(i10)') itotalqm
      write(4,8002)
 8000 format ('geometry={')
 8002 format ('TITLE')


      ltypname = 2
      typname  = qmtypname
      do i = 1, 3
        if (tfid(i) .ne. 0) then
          call ggeom(tfid(i),geom,fragid,asym,afrag,fgeom)
          do j = 1, afrag(tfid(i))
            if (inormal .eq. 1) then               
c
c the normal qm part
c
              write(4,4000) asym(fragid(tfid(i),j)), fgeom(j,1),
     *             fgeom(j,2), fgeom(j,3)
            else
c
c mm parts 
c
              lsymbol = 0
              atmsymbol = asym(fragid(tfid(i),j)) 	    	 
              do jj=1, 2
                if (atmsymbol(jj:jj) .ne. ' ') then 
                  lsymbol = lsymbol + 1
                endif 
	      enddo
              write(4,4000)
     *          atmsymbol(:lsymbol),fgeom(j,1), fgeom(j,2), fgeom(j,3)
            endif  
          end do
        end if
      end do

 4000 format (a,',',(d16.9),',',(d16.9),',',(d16.9))

c
c For oniom & mm input, we add background point charges in lattice
c
      if (inormal .eq. 0) then
        mmatmsymbol = chargename
        lsymbol   = 2
        mmtypname   = chargetypname
        ltypname  = 2
        itotalbq   = 0

        do i = 1, nfrg
          if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3))) then
            do j = 1, afrag(i)
              id = fragid(i,j)
c debug
c              write(*,*) 'i= ',i, 'j= ', j, 'id= ', id

              call gbgq(id,bgq,bq,nbgq,asym)
              itotalbq = itotalbq + 1
c
c Note: bq is character, not double precision
c    
              write (24,4001)
     *             geom(id,1), geom(id,2), geom(id,3),bq
            end do
          else
          end if
        end do
        write(4,*)
        write(24,*)
      end if

 4001 format ((f16.9),',',(f16.9),',',(f16.9),',',(a20),',1')
 4500 format (2x,i6,2x,i6,2x,f4.2)
 4110 format ('He    ',3f12.8,'  ')      
          
      write(4,'(a1)') '}'
      if (inormal .eq. 0) then 
         write(4,4650) latfile
         write(4,*)
      endif
 4650 format ('lattice,infile=',(a20))

c
C  if specifying a general basis set write the basis set info here
c
      if (bkey(1:3) .eq. 'gen') then
         write(4,4653) basis(1)(2:80)
      else
         write(4,4651) temp(bstr:bfin)
      end if
     
 4651 format('basis=',(a20))
 4653 format('include,',(a80),',echo')
      write(4,*)
      write(4,4652) mlt-1,chrg
 4652 format('{hf;wf,spin=',(i3),',charge=',(i3),'}')
      write(4,'(a20)') method(1:mfin)


 2000 format(a4,a,a,a1,a,a,a)
 2010 format(a4,a,a,a,a,a,a)
 2020 format(a,a,a,a)
 2030 format(a,a)


      go to 9999

 1000 write(2,1010)  infile
      close(4)
      stop 'wg09 1'
 1001 format('memory,',a10,', ',a1)

 1003 format(4a,2(3x,a))
 1010 format (3x, 'Error writting input file' , a20)

 1012 format (2(i2))
 1014 format(a3,',',f15.8,',',f15.8,',',f15.8) 
 1015 format(3(f15.5),a15)
 1016 format(3(f12.8),'  ',a20)

 9999 close(4)
c
c Added by Hai Lin, 5/11/2009
c     
      if (inormal .eq. 0) close(24)
c
c   Now we pass inormal as the 4th arguement to g09shuttle indicating 
c   if additional mm calculation needed to be done
c 
c      command = 'perl g09shuttle.pl ' // temp2(tbeg:tend)
c     *            //' '// eec(ebeg:eend) // ' 0 >> energy'

      if (icaltype .eq. 0) then 
        ccaltype = '0 '
      else if (icaltype .eq. 1) then
        ccaltype = '1 '
      else if (icaltype .eq. 2) then
        ccaltype = '2 '
      else
      endif

      if (inormal .eq. 0) then
        cnormal = '0 '
      elseif (inormal .eq. 1) then    
        cnormal = '1 '
      endif

        command = 'perl molpshuttle.pl ' // temp2(tbeg:tend)
     *    //' '// eec(ebeg:eend) //  ccaltype // cnormal // 
     *    ' ' // ctotalqm(qbeg:qend) // ' ' // cpop(1:pfin) //         
     *    ' ' // cmode(1:1) // ' > ' // temp2(tbeg:tend) // '_' //      
     *    eec(ebeg:eend-1) // '.eemb'                                   

      call system(command)

      return
      end
















C******************************************************************************
C
C     MOLPHF  
C
C******************************************************************************
C
C
C       Created: Jun 22, 2012 by H Qi
C       Purpose: to set up the full-system hartree fock (HF) calculation
C                that is needed to run an EE-MB-CE calculation, in molpro
C
C       Note: based on the setuphf subroutine
C
      subroutine molphf(natms,method,basis,nbasis,bkey,cm,asym,geom,
     *                   icaltype,keywrds,pseudo,core,ncore,mem)

      implicit none
      include 'common.inc'

      integer  natms,nbasis,icaltype,pseudo,ncore
      integer  cm(maxfrag,2)
      integer  mfin,mend,bfin,bend,bstr,charge,mult
      integer  nfin,nend,nstr
      integer  i,j,k,l,m,n

      character*80 basis(1000),keywrds,core(1000)
      character*80 temp,temp3,temp4,command
      character*20 bkey,method,infile,mem,cnatms
      character*3  ccaltype

      integer mmb, mme, mms, ierr 


       infile = 'fullhf_1.inp'         

C  if method is CCSD(T) or QCISD(T) change method to get full MP4 energy
C  as well
c
       if (method(1:7) .eq. 'ccsd(t)') then
            method = 'ccsd(t,e4t)'
       elseif (method(1:8) .eq. 'qcisd(t)') then
            method = 'qcisd(t,e4t)'
       end if

c
c Now open the g09 input file for writing
c
      open(unit=4,file=infile,form='formatted',status='unknown',
     *      err=1000)
c
c Print memory information
c
      mms=1
      mmb=1
      mme=1
      call fchar(mem,mms,ierr)
      mmb=mms
      call fspace(mem,mms,ierr)
      mme=mms-3                       ! assumes input has mw at the end of the mem string

      write(4,1001) mem(mmb:mme), mem(mme+1:mme+2)

C
c Write the title
c
      write(4,'(a11)') 'geomtyp=xyz'
      write(4,8000)
      write(4,'(i10)') natms
      write(4,8002)
 8000 format ('geometry={')
 8002 format ('TITLE')
c
C  print route information
C  find the end of the basis set and method specifications
c
       mfin = 1
       mend = 1
c
      call fspace(method,mfin,mend)
      mfin = mfin - 1
      if (bkey(1:3) .eq. 'lib') then
        temp = basis(1)
      elseif (bkey(1:3) .eq. 'gen') then
        temp = bkey(1:3)
      end if
      bfin = 1
      bend = 1
      call fchar(temp,bfin,bend)
      bstr = bfin
      call fspace(temp,bfin,bend)
      bfin = bfin - 1
c 
c  Figure out the charge and multiplicity of the large system.
c    NOTICE that the program currently assumes that all fragment
c    multiplicities are the same as one another and as that of
c    the entire system.
c
      charge = 0
      do i=1,maxfrag
        charge = charge + cm(i,1)
      end do
 
      mult = cm(1,2)                   ! See NOTICE above

c      write(4,*)
c      write(4,1012) charge,mult
c
c  Write the geometry of the entire system to the Gaussian input file
c
      do i=1,natms
        write(4,1014) asym(i), geom(i,1), geom(i,2), geom(i,3)
      end do
      write(4,*)

c
c  store the calculation type as a character variable 
c   (0 => energy, 1 => gradient, 2 => hessian)
c
      if (icaltype .eq. 0) then
        ccaltype = '0 '
      else if (icaltype .eq. 1) then
        ccaltype = '1 '
      else if (icaltype .eq. 2) then
        ccaltype = '2 '
      else
      endif
c
c  store the number of atoms in the system as a character variable
c
      write(cnatms,*) natms
      nfin = 1
      nend = 1
      call fchar(cnatms,nfin,nend)
      nstr = nfin
      call fspace(cnatms,nfin,nend)
      nfin = nfin -1

      write(4,'(a1)') '}'
c
C  if specifying a general basis set write the basis set info here
c
      if (bkey(1:3) .eq. 'gen') then
         write(4,4653) basis(1)(2:80)
      else
         write(4,4651) temp(bstr:bfin)
      end if
     
 4651 format('basis=',(a20))
 4653 format('include,',(a80),',echo')
      write(4,*)
      write(4,4652) mult-1,charge
 4652 format('{hf;wf,spin=',(i3),',charge=',(i3),'}')


c
c  call the g09shuttle.pl script to run the full HF calculation
c
      command = 'perl molpshuttle.pl fullhf 1 '// ccaltype // '1 '
     *          // cnatms(nstr:nfin) // ' none 1 >> fullhf_1.txt'      
   
      call system(command)

      go to 9999

 1000 write(2,1010)  infile
      close(4)
      stop 'setuphf 1'

 1001 format('memory,',a10,', ',a1)

 1002 format('HF calculation on entire system for EE-MB-CE')
 1010 format (3x, 'Error writting input file' , a20)
 1012 format (2(i2))
 1014 format(a3,',',f15.8,',',f15.8,',',f15.8)

 1999 format('# ', a80)

 9999 continue 
      return
      
      end subroutine molphf
