C******************************************************************************
C
C     GETFRAG
C
C******************************************************************************
C
C
C       Created: October 9, 2006 
C       Revised:
C       Purpose: subroutine to generate all possible combinations
C
C       Description: iterates through and generates the arrays that 
C		     contain all possible fragments
C                       
C                       
C                       
C
      subroutine getfrag(nfrg,ftype,nf,frglst)

      include 'common.inc'
      integer frglst(maxlist,3), nf
      integer i, j, k, l, n, ftype

       if (ftype .eq. 1) then 
	  do j = 1, nfrg
             frglst(j,1) = j
             frglst(j,2) = 0
             frglst(j,3) = 0
             nf = j
          end do
       elseif (ftype .eq. 2) then
          n = 0
          do j = 1, nfrg - 1
             do k = j+1, nfrg
                n = n + 1
                frglst(n,1) = j
                frglst(n,2) = k
                frglst(n,3) = 0
                nf = n
              end do
          end do
       elseif (ftype .eq. 3) then
          n = 0
          do j =1, nfrg - 2
             do k = j+1, nfrg - 1
                do l = k+1, nfrg
                    n = n + 1
		    frglst(n,1) = j
		    frglst(n,2) = k
		    frglst(n,3) = l
		    nf = n
	        end do
             end do
          end do	
       else
	write(2,1100) eemb
	stop 'genfrag 2'
       end if

 
 1100 format (/3x, 'EEMB = ', i4, ' is not a valid option.')

      return
      end 
C**********************************************************************
C
C    CHGMLT
C
C**********************************************************************
C
C  created : October 12, 2006 by E. E. Dahlke
C  revised :
C  purpose : to caculate the charge and multiplicity for a set
C            of fragments
C
C

      subroutine chgmlt(id,cm,chrg,mlt)

      implicit none

      include 'common.inc'

      integer i,j
      integer chrg, mlt,  mult(3), cm(maxfrag,2), id(3)

      chrg = 0
      do i = 1, 3
         if (id(i) .ne. 0) then
            chrg = chrg + cm(id(i),1)
            mult(i) = cm(id(i),2)
         else
            mult(i) = cm(id(1),2)
         end if
      end do

      if ((mult(1) .eq. mult(2)) .and. (mult(1) .eq. mult(3))) then
         mlt = mult(1)
      else
          write(2,1013) mult(1), mult(2), mult(3)
          stop 'chgmlt 1'
      end if


 1013 format (/3x, 'Not all fragments in your cluster have the ',
     *         'same multiplicity : ', 3(i3))
      return

      end
C**********************************************************************
C
C   GBGQ
C
C**********************************************************************
C
C  created : October 12, 2006 by E. E. Dahlke
C  revised :
C  purpose : to find the correct back ground charge for the atom type

      subroutine gbgq(id,bgq,bq,nbgq,asym)

      implicit none

      include 'common.inc'
      integer id, nbgq,te,t2e, ierr
      integer i, flg
c      character*20 bgq(maxat,2), bq, temp
      character*20 bgq(maxat,5), bq, temp      !0602BW11
      character*20 temp2

      flg = 0
      te = 1

      temp = asym(id)
      call fspace(temp,te,ierr)
      te = te - 1
      do i = 1, nbgq
        t2e = 1
        temp2 = bgq(i,1)
        call fspace(temp2,t2e,ierr)
        t2e = t2e - 1
        if (temp(1:te) .eq. temp2(1:t2e)) then
           bq = bgq(i,2)
           flg = 1
        end if
      end do

      if (flg .eq. 0) then
         write (2,1000) asym(id)
         stop 'gbgq 1'
      end if

 1000 format (/3x, 'Atom type ', a3, ' has not been given a charge ',
     *       'in section bqcharge.')

      return

      end
C**********************************************************************
C
C     GGEOM
C
C**********************************************************************
C
C  created : October 12, 2006 by E. E. Dahlke
C  revised :
C  purpose : to get the geometry for the right fragment
C

      subroutine ggeom(id,geom,fragid,asym,afrag,fgeom)

      implicit none
      include 'common.inc'

      integer id
      integer i, j
      integer fragid(maxfrag,maxapf), afrag(maxfrag)
      double precision fgeom(maxapf,3)

      do i = 1, afrag(id)
        do j = 1, 3
           fgeom(i,j) = geom(fragid(id,i),j)
        end do
      end do

      return
      end

C**********************************************************************
C
C   GBGQS
C
C**********************************************************************
C
C  created : June 1, 2011, by B. Wang 
C  revised :
C  purpose : to find the correct back ground charge, zeta value, number of electrons for screening,
C             and the nuclear charge for the atom type

      subroutine gbgqs(id,bgq,bq,nbgq,asym,zeta,nscn,nuc)

      implicit none 

      include 'common.inc'
      integer id, nbgq,te,t2e, ierr
      integer i, flg
      character*20 bgq(maxat,5), temp    
      character*20 temp2
      double precision bq,zeta, nscn,nuc 
      double precision cfloat

      flg = 0
      te = 1 

      temp = asym(id)
      call fspace(temp,te,ierr)
      te = te - 1
      do i = 1, nbgq
        t2e = 1
        temp2 = bgq(i,1)
        call fspace(temp2,t2e,ierr)
        t2e = t2e - 1
        if (temp(1:te) .eq. temp2(1:t2e)) then
           bq = cfloat(bgq(i,2))
           zeta=cfloat(bgq(i,3))
           nscn=cfloat(bgq(i,4)) 
           nuc=cfloat(bgq(i,5))
           flg = 1
        end if
      end do

      if (flg .eq. 0) then
        write (2,1000) asym(id)
         stop 'gbgq 1'
      end if

 1000 format (/3x, 'Atom type ', a3, ' has not been given a charge ',
     *       'in section bqcharge.')

      return

      end

C**********************************************************************
C
C   GMMPP
C
C**********************************************************************
C
C  created : August 25, 2011, by B. Wang
C  revised :
C  purpose : to find the correct pseudopotentials for the mm charge for the atom type
C

      subroutine gmmpp(id,asym,nallmmpp,allmmpp,immpp,mmpp,nmmpp,
     &                                               ngterm,maxl)

      implicit none

      include 'common.inc'
      integer id, immpp,nmmpp,ngterm,nallmmpp,maxl,ierr
      integer i,j,te,t2e
      character*80 mmpp(50),allmmpp(1000),temp,temp2
      integer itry
      character*1 xlett

      immpp = 0
      te = 1

      temp = asym(id)
      call fspace(temp,te,ierr)
      te = te - 1
      do i = 1, nallmmpp
        t2e = 1
        read (allmmpp(i),*) temp2
C
C change the first letter into upper case and others into lower case
C
        do j = 1, 80
          xlett = temp2(j:j)
          itry = ichar (xlett)
          if (j .eq. 1) then
            if (xlett .ge. 'a' .and. xlett .le. 'z') then
              itry = itry - 32
              temp2(j:j) = char(itry)
            endif
          else
            if (xlett .ge. 'A' .and. xlett .le. 'Z') then
              itry = itry + 32
              temp2(j:j) = char(itry)
            endif
          endif
        enddo

        call fspace(temp2,t2e,ierr)
        t2e = t2e - 1

        if (temp(1:te) .eq. temp2(1:t2e)) then
           read(allmmpp(i+1),*) nmmpp,ngterm,maxl
           do j=1, nmmpp
             mmpp(j)=allmmpp(i+1+j)
           enddo
           immpp = 1
           exit
        end if
      end do

      return

      end
C*****************************************************************************


