c*****************************************************************************
C
C      HHOOKS
C
c******************************************************************************
C
C      this is the subroutine to call the appropriate hessian hook
C
C       created : April 25, by E. E. Dahlke
C       revised : May 11, 2009 by Hai Lin
C		  June 10, 2009 by Erin Dahlke Speetzen
C                 March 9, 2011 by Hannah Leverentz
c
C       purpose : to call the right hessian hook
c       Revision: add a control vaiable icaltype, which indicates hessian 
c                 calculation when going eg09; hg09 is not used any more.
c                 03/09/2011 revised to allow EE-MB population/charge analyses

      subroutine hhooks(natms,rstrt,eemb,fragid,cm,afrag, nfrg,
     *                  basis,title,bgq,esm,method,geom,asym,nbasis,
C  Add by Hannah Leverentz, 3/9/2011
c    *                  mem,nbgq,bkey,keywrds,core,pseudo,ncore)
     *                  mem,nbgq,bkey,keywrds,core,pseudo,ncore,cpop,
     *                  lscreen,allmmpp,nmmpp,mmpseudo,leembce)                 ! 0617HL11 add lscreen  0825BW11; 1115HL11 add leembce
C  End by Hannah Leverentz, 3/9/2011


      implicit none
      include 'common.inc'

      integer   natms, rstrt, eemb,  nfrg, nf,nbasis, nbgq
      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer   frglst(maxlist,3), nftc
      integer   joblist(maxjob,5),nolig(3),imrk                                 !0523HL12
      integer   nm, nd, nt, tstrt, tfin, tend,  iistrt, jj, jstrt,ij
      integer i, j,k, tfid(3)                                                   !0523HL12 deleted ", donef(maxlist)"
      integer donef(maxjob),njtc                                                !0523HL12
C  added 6/10/09 by EDS
      integer   pseudo, ncore
C  end 6/10/09 EDS
c
c Added by Hai Lin, 5/11/2009
c
      integer   icaltype 
c
c End by Hai Lin, 5/11/2009
c
      character*80 basis(1000), title(5), string, temp
C  added 6/10/09 by EDS
      character*80 core(1000), keywrds
C  end 6/10/09 EDS
C  Add by Hannah Leverentz, 3/9/2011
      character*20 cpop
C  End by Hannah Leverentz, 3/9/2011
      character*20 bgq(maxat,5), esm, method,mem,  command,bkey  !0603BW11 change bgq(maxat,2) to bgq(maxat,5)
      character*30 tout
      character*6 tof
      character*1 cmode             !1115HL11
      integer lscreen				! 0617HL11  add lscreen
      double precision amass(maxat), hesspa(3*maxat,3*maxat)
      double precision hess3b(3*maxat,3*maxat)
      double precision h3b(maxhess), hpa(maxhess)
      double precision abohr, ageom(3*maxat)
      integer leembce               !1115HL11
      integer nmmpp,mmpseudo        !0825BW11
      character*80 allmmpp(1000)    !0825BW11

      data ABOHR /1.88972652D0/

c
c Added by Hai Lin, 5/11/2009
c
c   This idicates gradient calculations when calling eg09
c
      icaltype = 2
c
c End by Hai Lin, 5/11/2009
c
c Initialize the joblist array to zero.  See the comments at the        !0523HL12
c  beginning of the updtjobs subroutine for a description of the        !0523HL12
c  contents of the joblist array.                                       !0523HL12
c                                                                       !0523HL12
      joblist = 0                                                       !0523HL12
      njtc    = 0                                                       !0523HL12
      imrk    = 0                                                       !0523HL12

      do i = 1, eemb                                                    !0523HL12  rewrote
         call getfrag(nfrg,i,nf,frglst)                                 !0523HL12  this
         write(tout,*) i                                                !0523HL12  entire
         tfin = 1                                                       !0523HL12  section -
         tend = 1                                                       !0523HL12  deleted
         call fchar(tout,tfin,tend)                                     !0523HL12  old lines
         tstrt = tfin                                                   !0523HL12  and replaced
         call fspace(tout,tfin,tend)                                    !0523HL12  with these.
         tfin = tfin - 1                                                !0523HL12
         tof = tout(tstrt:tfin) // '.eemb'                              !0523HL12
         call updtjobs(rstrt,i,nf,frglst,njtc,tout,tstrt,tfin,imrk,     !0523HL12
     *                 joblist,donef)                                   !0523HL12
         nolig(i) = nf                                                  !0523HL12
      end do                                                            !0523HL12
                                                                        !0523HL12
                                                                        !0523HL12
C   if an eembce calculation is requested, the last job                 !0523HL12
C   described in joblist will be the full hartree-fock                  !0523HL12
C   calculation, denoted by a value of "-1" in each column              !0523HL12
C   of row 1:                                                           !0523HL12
                                                                        !0523HL12
      if (leembce.eq.1) then                                            !0523HL12
        cmode(1:1) = '1'                                                !0523HL12
        imrk = imrk + 1                                                 !0523HL12
        njtc = njtc + 1                                                 !0523HL12
        do i=1,5                                                        !0523HL12
          joblist(imrk,i) = -1                                          !0523HL12
        end do                                                          !0523HL12
        if (rstrt.ne.0) then                                            !0523HL12
          call fndstrt3(imrk,-1,donef,njtc,'null',1,1)                  !0523HL12
        endif                                                           !0523HL12
      else                                                              !0523HL12
        cmode(1:1) = '0'                                                !0523HL12
      end if                                                            !0523HL12

C  write and run the electronic structure input files

      do i = 1, imrk                                                 !0523HL12  This portion of
        if (donef(i).eq.0) then                                      !0523HL12  the code was rewritten;
          do k = 1, 3                                                !0523HL12  it replaces a segment
            tfid(k) = joblist(i,k+2)                                 !0523HL12  of the old code.
          end do                                                     !0523HL12
          if (esm .eq. 'g09') then                                   !0523HL12
            if (tfid(1).eq.-1) then                                  !0523HL12
              call setuphf(natms,method,basis,nbasis,bkey,cm,asym,   !0523HL12
     *                     geom,icaltype,keywrds,pseudo,core,ncore,  !0523HL12
     *                     mem)                                      !0523HL12
            else                                                     !0523HL12
              call eg09(natms,fragid,cm,afrag,nfrg,basis,            !0523HL12
     *                  title,bgq,method,geom,asym,tfid,joblist(i,2),!0523HL12
     *                  nbasis,mem,nbgq,joblist(i,1),bkey,icaltype,  !0523HL12
     *                  keywrds,core,pseudo,ncore,cpop,lscreen,      !0523HL12
     *                  allmmpp,nmmpp,mmpseudo,cmode)                !0523HL12
            endif
          elseif (esm .eq. 'nwchem') then                            !0523HL12
C              call enwchem()                                        !0523HL12
          end if                                                     !0523HL12
        end if                                                       !0523HL12
      end do                                                         !0523HL12

C  print the energy, dipole, gradient, and hessian information

C  Add by Hannah Leverentz, 3/9/2011
c     call wg09h(eemb,nfrg,natms,afrag,fragid,hpa,h3b)
      call wg09h(eemb,nfrg,natms,afrag,fragid,hpa,h3b,asym,cpop)
C  End by Hannah Leverentz, 3/9/2011

C  calculate the EEPA and EE3B frequencies and normal modes
C  start by assigning the atomic masses to each atom
      do i = 1, natms
	amass(i) = 0.0d0
      end do

      call ratoms(natms,asym,amass)

C  convert the geometry matrix to an array containing the coordinates in bohr
       ij = 1
       do i = 1, natms
          do j = 1, 3
             ageom(ij) = geom(i,j)*abohr
             ij = ij + 1
          end do
        end do
          
C  next expand the hessian from a lower triangular matrix to a square matrix
C  and call the program to calculate the frequencies

C  EE-PA frequencies

      write(2,1506)

      write(2,1504)
      call expnd(hpa,hesspa,3*maxat,0)
      call freqcal(ageom,amass,natms,hesspa)

C  EE-3B frequencies

      write(2,1506)

      write(2,1505)
      if (eemb .eq. 3) then
          call expnd(h3b,hess3b,3*maxat,0)
          call freqcal(ageom,amass,natms,hess3b)
      end if

      return


 9999 write(2,1010) tof
 1010 format (/3x, 'ERROR:  could not open file ', a6)

 1504 format(/3x,'EEPA Frequencies and Normal Modes')
 1505 format(/3x,'EE3B Frequencies and Normal Modes') 
 1506 format(/,80('_'),/,80('_'))



      end

C*****************************************************************************
C
C      WG09H
C
C****************************************************************************
c
C     created : by E. E. Dahlke
C     revised : May 11, 2009 by Hai Lin
C               March 9, 2011 by Hannah Leverentz
c
C     purpose : to write energy, dipole, gradient and hessian 
c     information to output file
C     Revision: pass nfrg information to g09outg subroutine
C               3/9/2011 - revised to allow EE-MB population/charge analyses

C  Add by Hannah Leverentz, 3/9/2011
c     subroutine wg09h(eemb,nfrg,natms,afrag,fragid,hpa,h3b)
      subroutine wg09h(eemb,nfrg,natms,afrag,fragid,hpa,h3b,asym,cpop)
C  End by Hannah Leverentz, 3/9/2011

      implicit none
      include 'common.inc'

      integer natms, eemb, nfrg, afrag(maxfrag) , i, j
      integer   fragid(maxfrag,maxapf), nf
      integer   frglst(maxlist,3), eflg(maxe)
      double precision menergy(maxe), denergy(maxe)
      double precision tenergy(maxe), v1(maxe), v2(maxe), v3(maxe)
      double precision eepa(maxe), ee3b(maxe)
      double precision gpa(3*maxat), g3b(3*maxat)
      double precision gv1(3*maxat), gv2(3*maxat), gv3(3*maxat)
      double precision mgrad(3*maxat), dgrad(3*maxat), tgrad(3*maxat)
      double precision dippa(3), dip3b(3), mdip(3), ddip(3), tdip(3)
      double precision dv1(3), dv2(3), dv3(3)
      double precision mhess(maxhess), dhess(maxhess), thess(maxhess)
      double precision hpa(maxhess)
      double precision h3b(maxhess), hv1(maxhess)
      double precision hv2(maxhess), hv3(maxhess)
      character*6 t1                                            !0213HL12 changed tof from a 6-char variable
      character*2 tof                                           !0213HL12  to a 2-character variable
      character*30 etype(maxe)
C  Add by Hannah Leverentz, 3/9/2011
      double precision totdippa, totdip3b
      double precision mqqm(maxat),dqqm(maxat),tqqm(maxat)
      double precision qqmpa(maxat),qqm3b(maxat)
      character*20 cpop
C  End by Hannah Leverentz, 3/9/2011
      double precision dip1b(3),totdip1b,qqm1b(maxat)           ! 1110HL11

C  zero all energies
      do i = 1, maxe
         eepa(i) = 0
         ee3b(i) = 0 
         v1(i) = 0
         v2(i) = 0
         v3(i) = 0
      end do  
                 
C  zero all dipoles        
      do i = 1, 3          
        dip1b(i) = 0                                            ! 1110HL11
        dippa(i) = 0 
        dip3b(i) = 0
      end do  

c  Add by Hannah Leverentz, 3/2/2011
c
C  zero the partial charges obtained from oligomer wave functions
      mqqm = 0
      dqqm = 0
      tqqm = 0
c
C  zero the eepa and ee3b estimates of partial charges from the wave function
C    of the entire system
      qqm1b = 0                                                 ! 1110HL11
      qqmpa = 0
      qqm3b = 0
c
c  End by Hannah Leverentz, 3/2/2011

C  zero all gradients
      do i = 1, 3*natms
          gv1(i) = 0
          gv2(i) = 0
          gv3(i) = 0
          gpa(i) = 0
          g3b(i) = 0
      enddo

C  zero all hessians
      do i = 1, maxhess
          hv1(i) = 0
          hv2(i) = 0
          hv3(i) = 0
          hpa(i) = 0
          h3b(i) = 0
      end do

C  get info out of *.eemb files

      do i = 1, eemb
         call getfrag(nfrg,i,nf,frglst)
c
c Revised by Hai Lin, 5/11/2009
c
c   Pass nfrg to g09outh subroutine
c
         if (i .eq. 1) then
            tof = '_1'                                 !0213HL12 changed tof from '1.eemb' to '_1'
            call g09outh(tof,nf,menergy,eflg,etype,natms,mgrad,mdip,
c     *                      mhess,fragid,frglst,afrag)
c  Add by Hannah Leverentz, 3/2/2011
c    *                      mhess,fragid,frglst,afrag,nfrg)
     *                      mhess,fragid,frglst,afrag,nfrg,mqqm)
c  End by Hannah Leverentz, 3/2/2011
         elseif (i .eq. 2)  then
            tof = '_2'                                 !0213HL12 changed tof from '2.eemb' to '_2'
            call g09outh(tof,nf,denergy,eflg,etype,natms,dgrad,ddip,
c     *                       dhess,fragid,frglst,afrag)
c  Add by Hannah Leverentz, 3/2/2011
c    *                       dhess,fragid,frglst,afrag,nfrg)
     *                       dhess,fragid,frglst,afrag,nfrg,dqqm)
c  End by Hannah Leverentz, 3/2/2011
          elseif (i .eq. 3) then
            tof = '_3'                                 !0213HL12 changed tof from '3.eemb' to '_3'
            call g09outh(tof,nf,tenergy,eflg,etype,natms,tgrad,tdip,
c     *                        thess,fragid,frglst,afrag)
c  Add by Hannah Leverentz, 3/2/2011
c    *                        thess,fragid,frglst,afrag,nfrg)
     *                        thess,fragid,frglst,afrag,nfrg,tqqm)
c  End by Hannah Leverentz, 3/2/2011
          end if
c
c End by Hai Lin, 5/11/2009
c
       end do

C  calculate the EEPA and EE3B energies
         do j = 1, maxe
            if (eflg(j) .eq. 1 ) then
                eepa(j) = denergy(j) - (nfrg-2)*menergy(j)
                v1(j) = menergy(j)
                v2(j) = denergy(j) - (nfrg-1)*menergy(j)
            end if
            if (eemb .eq. 3) then
              if (eflg(j) .eq. 1 ) then
                  ee3b(j) = tenergy(j) - (nfrg-3)*denergy(j)
                  ee3b(j) = ee3b(j) + (nfrg-2)*(nfrg-3)*menergy(j)/2
                  v3(j) = tenergy(j) - (nfrg-2)*denergy(j) +
     *                             (nfrg-2)*(nfrg-1)*menergy(j)/2
              end if
            end if
         end do

C  write header to file with information about V1, V2, and V3 and
C  what types of energy are reported

      if (eemb .eq. 2) then
         write(2,1210)
      elseif (eemb .eq. 3) then
         write(2,1220)
      end if

C  write V1, V2, and V3 (if appropriate to output file for each type of energy

      do i = 1, maxe
         if (eflg(i) .eq. 1) then
             if (eemb .eq. 2 ) then
                write(2,1230) etype(i), v1(i), v2(i)
             elseif (eemb .eq. 3) then
                write(2,1240) etype(i), v1(i), v2(i), v3(i)
             endif
         end if
      end do


C  write header to file with information about EEPA/EE3B and what types
C  of energy are reported
      if (eemb .eq. 2) then
          write(2,1300)
      elseif (eemb .eq. 3) then
          write(2,1400)
      end if

C  write eepa and ee3m (if appropriate) to output file for each type of energy

      do i = 1, maxe
         if (eflg(i) .eq. 1) then
            if (eemb .eq. 2) then
               write(2,1100) etype(i), eepa(i)
            elseif (eemb .eq. 3) then
               write(2,1200) etype(i), eepa(i), ee3b(i)
            end if
         end if
      end do


C  calculate the EEPA and EE3B dipole moments
         
      do j = 1, 3
         dip1b(j) = mdip(j)                                     ! 1110HL11
         dippa(j) = ddip(j) - (nfrg-2)*mdip(j)
         if (eemb .eq. 3) then 
            dip3b(j) = tdip(j) - (nfrg-3)*ddip(j)
            dip3b(j) = dip3b(j) + (nfrg-2)*(nfrg-3)*mdip(j)/2
         endif  
      end do

C  Add by Hannah Leverentz, 3/9/2011
c  calculate the EEPA and EE3B total dipole
c
      totdip1b = sqrt(dip1b(1)**2 + dip1b(2)**2 + dip1b(3)**2)          ! 1110HL11
      totdippa = sqrt(dippa(1)**2 + dippa(2)**2 + dippa(3)**2)
      totdip3b = sqrt(dip3b(1)**2 + dip3b(2)**2 + dip3b(3)**2)
c
C  End by Hannah Leverentz, 3/9/2011

C  write dipole moment information

      write(2,1501)

      write(2,1504) dip1b(1)*au2debye, dip1b(2)*au2debye,               ! 1110HL11
     *              dip1b(3)*au2debye, totdip1b*au2debye                ! 1110HL11

C  Add by Hannah Leverentz, 3/9/2011
c     write(2,1502) dippa(1), dippa(2), dippa(3)
      write(2,1502) dippa(1)*au2debye, dippa(2)*au2debye,               ! HL110413 bug fix
     *              dippa(3)*au2debye, totdippa*au2debye                ! HL110413 bug fix
C  End by Hannah Leverentz, 3/9/2011
      if (eemb .eq. 3) then
C  Add by Hannah Leverentz, 3/9/2011
c         write(2,1503) dip3b(1), dip3b(2), dip3b(3)
          write(2,1503) dip3b(1)*au2debye, dip3b(2)*au2debye,           ! HL110413 bug fix
     *                  dip3b(3)*au2debye, totdip3b*au2debye            ! HL110413 bug fix
C  End by Hannah Leverentz, 3/9/2011
      end if

C  Add by Hannah Leverentz, 3/9/2011
c
C Calculate the atomic partial charges
c
      do j = 1, natms
         qqm1b(j) = mqqm(j)                                             ! 1110HL11
         qqmpa(j) = dqqm(j) - (nfrg-2)*mqqm(j)
         if (eemb .eq. 3) then
            qqm3b(j) = tqqm(j) - (nfrg-3)*dqqm(j)
            qqm3b(j) = qqm3b(j) + (nfrg-2)*(nfrg-3)*mqqm(j)/2
         endif
      end do
c
C write the atomic partial charges to the output file
c
      if (cpop(1:4).ne."none") then
        write(2,1530)
        write(2,1540) cpop
        if (eemb.eq.2) then
          write(2,1550)
          do j = 1, natms
            write(2,1560) j, asym(j), qqm1b(j), qqmpa(j)                ! 1110HL11  added qqm1b(j)
          end do
        else if (eemb.eq.3) then
          write(2,1570)
          do j = 1, natms
            write(2,1580) j, asym(j), qqm1b(j), qqmpa(j), qqm3b(j)      ! 1110HL11  added qqm1b(j)
          end do
        end if
      end if 
c
C  End by Hannah Leverentz, 3/9/2011


C  calculate the EEPA and EE3B gradients

      do j = 1, 3*natms
         gpa(j) = dgrad(j) - (nfrg-2)*mgrad(j)
         gv1(j) = mgrad(j) 
         gv2(j) = dgrad(j) - (nfrg-1)*mgrad(j)
         if (eemb .eq. 3) then
            g3b(j) = tgrad(j) - (nfrg-3)*dgrad(j)
            g3b(j) = g3b(j) + (nfrg-2)*(nfrg-3)*mgrad(j)/2 
            gv3(j) = tgrad(j) - (nfrg-2)*dgrad(j) +
     *                   (nfrg-2)*(nfrg-1)*mgrad(j)/2
         end if
       end do
                
C  write gradient information
      write(2,1405)
             
      do i = 1, natms
         write(2,1410) gpa(3*(i-1)+1), gpa(3*(i-1)+2), gpa(3*(i-1)+3)
      end do

      if (eemb .eq. 3) then
        write(2,1415)
        do i = 1, natms
           write(2,1410) g3b(3*(i-1)+1), g3b(3*(i-1)+2), g3b(3*(i-1)+3)
        end do
      end if
      
C  calculate the EEPA and EE3B hessians

      do j = 1, 3*natms*(3*natms+1/2)
         hpa(j) = dhess(j) - (nfrg-2)*mhess(j)
         hv1(j) = mhess(j)
         hv2(j) = dhess(j) - (nfrg-1)*mhess(j)
         if (eemb .eq. 3) then
             h3b(j) = thess(j) - (nfrg-3)*dhess(j)
             h3b(j) = h3b(j) + (nfrg-2)*(nfrg-3)*mhess(j)/2
             hv3(j) = thess(j) - (nfrg-2)*dhess(j) +
     *                   (nfrg-2)*(nfrg-1)*mhess(j)/2
         end if
      enddo

C  print the EEPA and EE3B hessians
      write(2,1419)
      write(2,1420) (hpa(i), i= 1, 3*natms*(3*natms+1)/2)
      if (eemb .eq. 3) then
         write(2,1421)
         write(2,1420) (h3b(i), i= 1, 3*natms*(3*natms+1)/2)
      end if

 1100 format(3x,a30,f20.10)
 1200 format(3x,a30,f20.10,t60,f25.10)
 1210 format(/,/3x,'Type of Energy',t40, '  V1 (Hartrees)  ', t60,
     *        '  V2 (Hartrees)  ',/3x,'--------------',t40,
     *        '-----------------', t60,'-----------------')
 1220 format(/,/3x,'Type of Energy',t40, '  V1 (Hartrees)  ', t60,
     * '  V2 (Hartrees)  ',t80, '  V3 (Hartrees)  ',/3x,
     * '--------------',t40,'-----------------', t60,
     * '-----------------',t80, '-----------------')
 1230 format(3x,a30,f20.10,t55,f20.10)
 1240 format(3x,a30,f20.10,t55,f20.10,t75,f20.10)
 1300 format(/,/3x,'Type of Energy',t35, 'EE-PA Energy (Hartrees)',
     *          /3x,'--------------',t35, '-----------------------')
 1400 format(/,/3x,'Type of Energy',t35,'EE-PA Energy (Hartrees)',
     *       t65, 'EE-3B Energy (Hartrees)',/3x,'--------------',t35,
     *      '-----------------------',t65,'-----------------------')
 1405 format(/,/3x,'EE-PA Gradient (Hartrees/Bohr)')
 1410 format(10x,f12.8,f12.8,f12.8)
 1415 format(/,/3x, 'EE-3B Gradient (Hartrees/Bohr)')
 1419 format(/,/3x,'EE-PA Cartesian Force Constants (lower triang.)')
 1420 format(10x,f12.8,f12.8,f12.8)
 1421 format(/,/3x,'EE-3B Cartesian Force Constants (lower triang.)')
C  Add by Hannah Leverentz, 3/9/2011
c  1501 format(/3x,/'Dipole Moment')
c  1502 format(/3x,'EEPA Dipole Moment : ', f16.8, f16.8, f16.8)
c  1503 format(/3x,'EE3B Dipole Moment : ', f16.8, f16.8, f16.8)
 1501 format(/3x,/'Dipole Moment (in debye)',//'Warning: for ',
     *       'correlated wave function methods such as MP2 and ',
     *       'CCSD the dipole ',/9x,'moment is not calculated by ',
     *       'Gaussian 09',//20x,'X',15x,'Y',15x,'Z',13x,'TOTAL')
 1502 format(/3x,'EEPA: ', f16.8, f16.8, f16.8, f16.8)
 1503 format(/3x,'EE3B: ', f16.8, f16.8, f16.8, f16.8)
 1504 format(/3x,'EE1B: ',f16.8, f16.8, f16.8, f16.8)                   ! 1110HL11
 1530 format(/,/3x,'-----------------------------------------------',
     *         /3x,'             EE-MB CHARGE ANALYSIS',
     *         /3x,'-----------------------------------------------')
 1540 format(/3x,'Method of Charge Analysis: ',a20)
 1550 format(/3x,'                       EE-1B',9x,'EE-PA',             ! 1110HL11
     *       /3x,'Atom #    Element    Charge (e)    Charge (e)',       ! 1110HL11
     *       /3x,'------    -------   ------------  ------------')      ! 1110HL11
 1560 format(3x,i6,4x,a7,3x,f12.6,2x,f12.6)                             ! 1110HL11
 1570 format(/3x,'                       EE-1B',9x,'EE-PA',9x,'EE-3B',  ! 1110HL11
     *       /3x,'Atom #    Element    Charge (e)    Charge (e)',       ! 1110HL11
     *           '    Charge (e)',                                      ! 1110HL11
     *       /3x,'------    -------   ------------  ------------',      ! 1110HL11
     *           '  ------------')                                      ! 1110HL11
 1580 format(3x,i6,4x,a7,3x,f12.6,2x,f12.6,2x,f12.6)                    ! 1110HL11
C  End by Hannah Leverentz, 3/9/2011

       return 

       end

c******************************************************************************
C
C      HG09
C
c******************************************************************************
C
C      created : April 25th, 2007 by E. E. Dahlke (modified GG09)
C      revised : 
C      purpose :  write the G09 input files for hessian calc
C
C

      subroutine hg09(natms,fragid,cm,afrag,nfrg,basis,title,bgq,
     *                method,geom,asym,tfid,fn,nbasis,mem,nbgq,ee,bkey)


      implicit none
      include 'common.inc'

      integer   natms,  nfrg, fn, fn2, nbasis, len, bstr
      integer   mfin, mend, bfin, bend, tbeg, tend,tstrt,ierr
      integer   chrg, mlt, nbgq, flg, id,ee, estrt, eend, ebeg
      integer   i,j
      integer   fragid(maxfrag,maxapf), cm(maxfrag,2), afrag(maxfrag)
      integer   tfid(3), istrt, iend, strt(3), end(3)
      character*80 basis(1000), title(5), temp, command, temp2, eec
      character*80 temp3
      character*20 bgq(maxat,2), method, infile, name(3),mem, bq
      character*20 chkfl, bkey
      double precision fgeom(maxapf,3)

      write(temp2,*) fn

C  make name of input file equal to the fragment number

      tstrt = 1
      call fchar(temp2,tstrt,ierr)
      tbeg = tstrt      
      call fspace(temp2,tstrt,ierr)
      tend = tstrt - 1
      infile = temp2(tbeg:tend) // '.g09'
      len = tend - tbeg + 5

C  make the name for the formated checkpoint file equal to 'fragment #'_'# of fragments'.FChk
      write(eec,*) ee
      estrt = 1
      call fchar(eec,estrt,ierr)
      ebeg = estrt
      call fspace(eec,estrt,ierr)
      eend = estrt
      chkfl = temp2(tbeg:tend) //'_'//eec(ebeg:eend)//'.FChk'
      

C  if method is CCSD(T) or QCISD(T) change method to get full MP4 energy 
C  as well
       if (method(1:7) .eq. 'ccsd(t)') then
            method = 'ccsd(t,e4t)'
       elseif (method(1:8) .eq. 'qcisd(t)') then
            method = 'qcisd(t,e4t)'
       end if

      open(unit=4,file=infile,form='formatted',status='unknown',
     *      err=1000)
C     print memory information
      write(4,1001) mem

C  print route information
C  find the end of the basis set and method specifications
      mfin = 0
      mend = 0
      call fspace(method,mfin,mend)
      mfin = mfin - 1
      if (bkey(1:3) .eq. 'lib') then
        temp = basis(1)
      elseif (bkey(1:3) .eq. 'gen') then
        temp = bkey(1:3)
      end if
      bfin = 1
      bend = 1
      call fchar(temp,bfin,bend)
      bstr = bfin
      call fspace(temp,bfin,bend)
      bfin = bfin - 1
      temp3 = '# '//method(1:mfin)//'/'//temp(bstr:bfin)
     *           //' SCF=(tight,maxcycle=500,xqc) '
     *           //' FChk=All Nosymm Charge'
     *           // ' Freq=noraman'
      write(4,'(a80)') temp3

      write(4,1002)

C  figure out charge and multiplicity for the smaller cluster
C  for version 1.0 all multiplicities must be the same.
      call chgmlt(tfid,cm,chrg,mlt)       
      write(4,*)
      write(4,1012) chrg, mlt

C  write the geometries of the fragment cluster to the file
      do i = 1, 3
        if (tfid(i) .ne. 0) then
         call ggeom(tfid(i),geom,fragid,asym,afrag,fgeom)
         do j = 1, afrag(tfid(i))
           write(4,1014) asym(fragid(tfid(i),j)), fgeom(j,1), 
     *             fgeom(j,2), fgeom(j,3)


         end do
        end if
      end do
      write (4,*)

C  if specifying a general basis set write the basis set info here
      if (bkey(1:3) .eq. 'gen') then
         do i = 1, nbasis
             write(4,'(a80)') basis(i)
         end do
         write(4,*)
       end if

C  write the coorinates and charges for the background charges
      do i = 1, nfrg
       if ((i.ne.tfid(1)).and.(i.ne.tfid(2)).and.(i.ne.tfid(3))) then
         do j = 1, afrag(i) 
          id = fragid(i,j)
          call gbgq(id,bgq,bq,nbgq,asym)
          write(4,1016) geom(id,1), geom(id,2), geom(id,3), bq
         end do
       else 
       end if
      end do

      write(4,*)


      go to 9999

 1000 write(2,1010)  infile
      close(4)
      stop 'ghooks 1'
 1001 format('%mem=',a20)
 1002 format(/,'title')
 1003 format(4a,2(3x,a))
 1010 format (3x, 'Error writting input file' , a20)

 1012 format (2(i2))
 1014 format(a3,3(f15.8)) 
 1015 format(3(f15.5),a15)
 1016 format(3(f12.8),'  ',a20)

 9999 close(4)
      
      command = 'perl g09shuttle.pl ' // temp2(tbeg:tend)
     *            //' '// eec(ebeg:eend) // ' 2  >> energy'
      call system(command)

      return

      end


C**********************************************************************
C
C    G09OUTH
C
C**********************************************************************
C
C   created : April 25 2007, by E. E. Dahlke (modified G09OUTG)
C   revised : May 11, 2009   by Hai Lin
C             Feb 17, 2011   by Hannah Leverentz
C             March 2, 2011  by Hannah Leverentz
c
C   purpose : to pull the energies, gradients, and dipole moments
C	      out of the *.eemb file (* = 1, 2, 3) 
C   revision: pass nfrg to subroutine getbqap             
C             2/17/2011 - revised to increase size of aplst array
C             3/2/2011  - revised to allow EE-MB population/charge analyses

      subroutine g09outh(tof,nf,energy,eflg,etype, natms,grad, dip,
c     *                        hess,fragid,frglst,afrag)
c  Add by Hannah Leverentz, 3/2/2011
c    *                        hess,fragid,frglst,afrag,nfrg)
     *                        hess,fragid,frglst,afrag,nfrg,qqm)
c  End by Hannah Leverentz, 3/2/2011

      implicit none
      include 'common.inc'
      integer nf, i, istrt, ierr, j, ii, natms, nl, ng, l
c
c Added by Hai Lin, 5/11/2009
c
      integer nfrg
c
c End by Hai Lin, 5/11/2009
c
      integer nh, nlh, hplst(maxhess), ne
c  Added by Hannah Leverentz, 2/17/2011
c     integer  aplst(maxapf*3), ibeg, ifin, iquit
      integer  aplst(maxat*3), ibeg, ifin, iquit
c  End by Hannah Leverentz, 2/17/2011
c
c Added by Hai Lin, 5/11/2009
c     
c  Added by Hannah Leverentz, 2/17/2011
c     integer  aplstbak(maxapf*3), ibak
      integer  aplstbak(maxat*3), ibak
c  End by Hannah Leverentz, 2/17/2011
c           
c End by Hai Lin, 5/11/2009
c
      integer eflg(maxe), fragid(maxfrag,maxapf), afrag(maxfrag)
      integer frglst(maxlist,3), na
      character*30 etype(maxe)
      character*2  tof                                  !0213HL12  changed tof from a 6-char variable to a 2-char variable
      character*10 flnm                                 !0213HL12
      character*80  ci                                  !0213HL12
      integer fstrt, fbeg, fend                         !0213HL12
      character*80 string, temp
      double precision energy(maxe), cenergy, senergy, tmpgrad, tmpdip
      double precision grad(3*maxat), dip(3), hess(maxhess), tmphess
c  Add by Hannah Leverentz, 3/2/2011
      double precision qqm(maxat)
c  End by Hannah Leverentz, 3/2/2011

C  open the *.eemb file

c     open(unit=3,file=tof,status='old',form='formatted',err=9999)     !0213HL12 commented out this line

C  and set all energies to zero, and clear array with the flags
      do i = 1, maxe
            energy(i) = 0
            eflg(i) = 0
      end do

C  zero the temporary dipole
      do i = 1, 3
	dip(i) = 0.0d0
      end do

c  Add by Hannah Leverentz, 3/2/2011
c
C  zero the QM partial charges array for the current oligomer type
      do i = 1, maxat
        qqm(i) = 0.0d0
      end do
c
c  End by Hannah Leverentz, 3/2/2011

C  zero the temporary gradient
      do i = 1, 3*natms
          grad(i) = 0
      end do

C  zero the temprorary hessian
      do i = 1, maxhess
          hess(i) = 0
      end do

C  store the data for each data type
      i = 1
      istrt = 1
      do while (i .le. nf)	
         write(ci,*) i                                                          !0213HL12
         fstrt = 1                                                              !0213HL12
         call fchar(ci,fstrt,ierr)                                              !0213HL12
         fbeg = fstrt                                                           !0213HL12
         call fspace(ci,fstrt,ierr)                                             !0213HL12
         fend = fstrt - 1                                                       !0213HL12
         flnm = ci(fbeg:fend) // tof // '.eemb'                                 !0213HL12
         open(unit=3,file=flnm,status='old',form='formatted',err=9999)          !0213HL12
	 ng = 1
         ne = 1
         read(3,'(a80)',err=9910) string
         call fspace(string,istrt,ierr)
         read(string(1:istrt),*) ii

C  figure out how many total gradient elements there are and then
C  figure out how many lines of gradient information there will be in 
C  the file for this fragment combination

         na = 0
         call getap(ii,fragid, frglst, afrag, aplst,na)
c
c Added by Hai Lin, 5/11/2009
c
c   Find the location of background charge gradient in the oniom FChk file
c   For normal QM (including using the charge keyworda), the gradients are 
c   available only for the QM atoms, as charges not counted as atoms.
c   For oniom and mm jobs, the gradients are given for all atoms.
c
         if (na .lt. natms*3) then
           call getbqap(ii,fragid, frglst, afrag, aplst,na,natms,nfrg)
c
c   Now set na to natms because we are reading the gradients for the whole 
c   system.
c
           na = natms*3
         endif
c
c   Now let us save a copy for the atom list just in case
c
         do ibak = 1, na
           aplstbak(ibak) = aplst(ibak) 
         end do
c
c End by Hai Lin, 5/11/2009
c
         if (mod(na,5) .eq. 0) then
                nl = na/5
         else
                nl = int(na/5) + 1
         end if

C  figure out how many total hessian elements there are and then
C  figure out how many lines of hessian information there will be in
C  the file for this fragment combination

         nh = 0
c
c Added by Hai Lin, 5/11/2009
c
c   Now that we need the components for all atoms and background 
c   charges, and the list is already given in array aplst(...)
c
c         call gethp(ii,fragid,frglst, afrag, hplst, nh)
         call getbqhp(ii,fragid,frglst, afrag, hplst, nh,
     *          na, aplstbak)
c debug
c         write(*,*) 'after bqhp, nh= ', nh

c
c End by Hai Lin, 5/11/2009
c
         if (mod(nh,5) .eq. 0) then
               nlh = nh/5
         else
               nlh = int(nh/5) + 1
         end if

C  continue reading the input file         

         read(3,'(a80)',err=9910) string
         read(string(38:50),'(f21.10)') senergy
c  revised 6/18/09 by EDS
c	 j = 0
         do while (string(1:12) .ne. 'Total Energy')
c	    j = j + 1
            read(3,'(a80)',err=9910) string
c            etype(j) = string(1:30)
            read(string(50:71),'(E22.15E2)') cenergy
            if (string(1:10) .eq. 'SCF Energy') then
               j = 1
               eflg(j) = 0
               etype(j) = string(1:30)
            elseif (string(1:10) .eq. 'MP2 Energy') then
               j = 2
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:10) .eq. 'MP3 Energy') then
               j = 3
               eflg(j) = 1
               etype(j)= string(1:30)
            elseif (string(1:11) .eq. 'MP4D Energy') then
               j = 4
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:12) .eq. 'MP4DQ Energy') then
               j = 5
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:13) .eq. 'MP4SDQ Energy') then
               j = 6
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:27) .eq.
     *                         'Cluster Energy with Triples') then
               j = 8
               eflg(j) = 1
               etype(j) = string(1:30)
            elseif (string(1:12) .eq. 'Total Energy') then
               j = 9
               eflg(j) = 1
               etype(j) = string(1:30)
            else
               j = 7
               eflg(j) = 1
               etype(j) = string(1:30)
            endif
            read(string(50:71),'(E22.15E2)') cenergy
            energy(j) = energy(j) + cenergy - senergy
c	    eflg(j) = 1
c
c Revised by Hai Lin, 5/11/2009
c
c   After we use oniom, the scf energy is meaningless and should not 
c   be shown. Look for the total energy to be on the safe side.
c
c            if (string(1:12) .eq. 'Total Energy') then
c            if (string(1:10) .eq. 'SCF Energy') then
c
c End by Hai Lin, 5/11/2009
c
c                eflg(j) = 0
c            end if
c  end revision 6/18/09 EDS
         end do
         read(3,'(a80)',err=9910) string
         read(3,'(a80)',err=9910) string

C  find the dipole moments

         istrt = 1
         ierr = 0
         do j = 1, 3
             call fchar(string, istrt, ierr)
             ibeg = istrt
             call fspace(string, istrt, ierr)
             ifin = istrt - 1
             temp = string(ibeg:ifin)
             read(unit=temp, fmt=*) tmpdip
             dip(j) = dip(j) + tmpdip
         end do
c  Add by Hannah Leverentz, 3/2/2011
c
C  read in the QM partial charges obtained from the oligomer wave function
c
         call readqqm(ii,frglst,fragid,qqm)
c
c  End by Hannah Leverentz, 3/2/2011

        read(3,'(a80)',err=9910) string

C  put the gradient in the right part of the gradient array based on the
C  fragment number and the list of atoms for each fragment
C  read each line until all lines containing gradient information have been
C  read in, put them all in a temporary array for right now, will move to the 
C  permanent arrays once they have all been read in

	j = 1
	do while (j .le. nl) 
	  read(3,'(a80)',err=9910) string
          istrt = 1
	  ierr = 0
	  ifin = 1
	  ibeg = 1
          l = 1	
	  do while (l .le. 5) 
	     if (ng .le. na) then
               call fchar(string, istrt, ierr)
               ibeg = istrt
               call fspace(string, istrt, ierr)
	       if (ifin .eq. 80) then
	         ifin = istrt - 1
               else
                 ifin = istrt
               end if
               temp = string(ibeg:ifin)
               read(unit=temp, fmt=*) tmpgrad
	       grad(aplst(ng)) = grad(aplst(ng)) + tmpgrad
               ng = ng + 1
		l = l + 1
             else 
		  l = 6
             end if
          end do
          j = j + 1
         end do

C  put the hessian in the right part of the hessian array based on the
C  fragment number and the list of atoms for each fragment
C  read each line until all lines containing hessian information
C  have been read in, put them all in a temporary array for right now, 
C  and then move them to their permanent place one they have all been 
C  read in

        read(3,'(a80)',err=9910) string
        j = 1
        do while (j .le. nlh)
          read(3,'(a80)',err=9910) string
          istrt = 1
          ierr = 0
          ifin = 1
          ibeg = 1
          l = 1
          do while (l .le. 5)
             if (ne .le. nh) then
               call fchar(string, istrt, ierr)
               ibeg = istrt
               call fspace(string, istrt, ierr)
               if (ifin .eq. 80) then
                 ifin = istrt - 1
               else
                 ifin = istrt
               end if
               temp = string(ibeg:ifin)
               read(unit=temp, fmt=*) tmphess
	       hess(hplst(ne)) = hess(hplst(ne)) + tmphess
               ne = ne + 1
               l = l + 1
             else
                l = 6
             end if
           end do
           j = j + 1
         end do

      close(3)                                               !0213HL12
      i = i + 1   
      end do

c     close(3)                                               !0213HL12 commented out this line

      return
 9999 write(2,1900) flnm					!0213HL12 changed 'tof' to 'flnm'
      stop 'g09cc 1'
 1900 format(/3x,'Error : could not open file ', a12)		!0213HL12 changed 'a6' to 'a12'

 9910 write(2,1800) flnm, nf					!0213HL12 changed 'tof' to 'flnm'
      stop 'g09cc 2'
 1800 format(/3x, 'Error: end of file ', a12, ' reached but ', i5,   !0213HL12 changed 'a6' to 'a12'
     *       ' energies not yet read')

      end

C**********************************************************************
C
C    GETHP
C
C**********************************************************************
C
C   created : April 25th, 2007 by E. E. Dahlke (modified GETAP)
C   revised :
C   purpose : given a fragment combination, find the corresponding 
C	      locations in the hessian array

      subroutine gethp(fn,fragid, frglst, afrag, hplst,np)

      implicit none
      include 'common.inc'
      integer i, j, k,l, np, fn, fragid(maxfrag,maxapf), afrag(maxfrag)
      integer frglst(maxlist,3), hplst(maxhess), na, list(maxhess)

      np = 1

C  zero array
      do i = 1, maxhess
          hplst(i) = 0
          list(i) = 0
      end do

C  create the full list of hessians rows from the atoms numbers and push
C  into an array
      l = 1
      do i = 1, 3
         if (frglst(fn,i) .ne. 0) then
            do j = 1, afrag(frglst(fn,i))
               do k = 1, 3
                  list(l) = 3*(fragid(frglst(fn,i),j)-1) + k
                  l = l + 1
               end do
            end do
          end if
       end do

       l = l -1

C  go through the list and find the position in the lower triangular hessian
C  matrix that the element would be in and convert to the position in the
C  1-D hessian array for the full system
 
       do i = 1, l
          do j = 1, i
             if (list(i) .ge. list(j)) then
                 hplst(np) = list(i)*(list(i)-1)/2 + list(j)
             else 
                 hplst(np) = list(j)*(list(j)-1)/2 + list(i)
             end if
             np = np + 1
          end do
       end do


      np = np - 1

      return
      end
C**********************************************************************
C
C    FNDSTRTH
C
C**********************************************************************
C
C   created : April 14, 2007 by E. E. Dahlke (modified FNDSTRT)
C   revised :
C   purpose : to find the last completed gradient calculation in a
C             restart

      subroutine fndstrth(nf,jstrt)

      implicit none

      integer nf, jstrt, i, j, istrt, ierr, ii
      character*80 string, efile


      efile = 'energy'

C  open the *.eemb file

      open(unit=5,file=efile,status='old',form='formatted',err=9999)

C  read in the data looking for the highest fragment number run

      i = 0
      jstrt = 0
      istrt = 1
      read(5,'(a80)',end=9998) string
      do while (i .lt. nf)
         call fspace(string,istrt,ierr)
         read(string(1:istrt),*) ii
         if (ii .gt. jstrt) then
             jstrt = ii
         end if
         read(5,'(a80)',end=9998) string
         do while (string(1:18) .ne. 'Cartesian Gradient')
            read(5,'(a80)',end=9998) string
         end do
         read(5,'(a80)',end=9998) string
         do while (string(1:1) .ne. 'Cartesian Force Constants')
            read(5,'(a80)',end=9998) string
         end do
         do while (string(1:1) .eq. ' ')
            read(5,'(a80)',end=9998) string
         end do
         i = i + 1
      end do

 9998 jstrt = jstrt + 1

      close (5)
      return

 9999 write(2,1900)
      stop 'fndstrth 1'

 1900 format (/3x, 'Error could not open file energy')



      end

C**********************************************************************
C
C    GETBQHP
C
C**********************************************************************
C
C   created : May 11, 2009 by Hai Lin
C   revised : Feb 17, 2011 by Hannah Leverentz
C   purpose : find the locations in the hessian array for a given 
c             list of atoms in the aplst gradient array

      subroutine getbqhp(fn, fragid, frglst, afrag, hplst, np, 
     *  na, aplstbak)

      implicit none
      include 'common.inc'
      integer i, j, k, l, np, fn, fragid(maxfrag,maxapf), afrag(maxfrag)
      integer frglst(maxlist,3), hplst(maxhess)
c  Added by Hannah Leverentz, 2/17/2011
c     integer na, aplstbak(maxapf*3)
      integer na, aplstbak(maxat*3)
c  End by Hannah Leverentz, 2/17/2011
      
      np = 1

C  zero array

      do i = 1, maxhess
          hplst(i) = 0
      end do

C  go through the list and find the position in the lower triangular hessian
C  matrix that the element would be in and convert to the position in the
C  1-D hessian array for the full system
 
       do i = 1, na
          do j = 1, i
             if (aplstbak(i) .ge. aplstbak(j)) then
                 hplst(np) = aplstbak(i)*(aplstbak(i)-1)/2 + aplstbak(j)
             else 
                 hplst(np) = aplstbak(j)*(aplstbak(j)-1)/2 + aplstbak(i)
             end if
             np = np + 1
          end do
       end do


      np = np - 1

      return
      end


